#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for setting devctrl"""

import os

import ionas.request as request
import ionas.nascmd as nascmd
import libfal.falcmd as falcmd
from fal_info import ReqTypes
from fal_info import Results
import pal_info
import fal_config as config


class FalDevctrl(falcmd.FalCmd):
    """FAL Devctrl command implementation class."""

    def __init__(self, option=None):
        """Constructor."""

        falcmd.FalCmd.__init__(self, option=option)

        pass_handler = \
            lambda entry: self.send_entry(entry, pal_info.PAL_DEVCTRL_PATH)

        self.set_handler(ReqTypes.CHK_EXIST, pass_handler)
        self.set_handler(ReqTypes.LIST, pass_handler)

#
# Main
#

if __name__ == "__main__":
    FalDevctrl(option=falcmd.FalCmdOption()).handle_request()
