#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for processing the events and event handler."""


import os

import ionas.nascmd as nascmd

import libfal.falcmd as falcmd
import pal_info
from fal_info import (ReqTypes,)

import fal_config as config


class FalEvents(falcmd.FalCmd):
    """FAL Events command implementation class."""

    def __init__(self, option=None):
        """Constructor."""

        falcmd.FalCmd.__init__(self, option=option)

        events_handler = lambda entry: self.send_entry(entry,
                                            pal_info.PAL_EVENTS_PATH)

        self.set_handler(ReqTypes.REGISTER, events_handler)
        self.set_handler(ReqTypes.UNREGISTER, events_handler)
        self.set_handler(ReqTypes.EVENT, events_handler)


#
# Main
#

if __name__ == "__main__":
    FalEvents(option=falcmd.FalCmdOption()).handle_request()
