#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for handling lcm function"""

import os
import ionas.nascmd as nascmd
import pal_info
import fal_config as config
import libfal.falcmd as falcmd
from fal_info import ReqTypes


class FalLcm(falcmd.FalCmd):
    """FAL LCM command implementation class."""

    def __init__(self, option=None):
        """Constructor."""

        falcmd.FalCmd.__init__(self, option=option)

        display_handler = \
            lambda entry: self.send_entry(entry, pal_info.PAL_LCM_PATH)

        self.set_handler(ReqTypes.DISPLAY, display_handler)

#
# Main
#

if __name__ == "__main__":
    FalLcm(option=falcmd.FalCmdOption()).handle_request()
