#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for setting lump regist"""

import os

import ionas.nascmd as nascmd
import libfal.falcmd as falcmd
from fal_info import ReqTypes
import pal_info
import fal_config as config


class FalLumpRegist(falcmd.FalCmd):
    """FAL Lump Regist command implementation class."""

    def __init__(self, option=None):
        """Constructor."""

        falcmd.FalCmd.__init__(self, option=option)

        pass_handler = lambda entry: self.send_entry(entry,
                        pal_info.PAL_LUMPREGIST_PATH)

        self.set_handler(ReqTypes.LUMP_REGIST, pass_handler)
        self.set_handler(ReqTypes.QUERY, pass_handler)
        self.set_handler(ReqTypes.APPLY, pass_handler)

#
# Main
#

if __name__ == "__main__":
    FalLumpRegist(option=falcmd.FalCmdOption()).handle_request()
