#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for managemnet the system state."""


import os

import ionas.nascmd as nascmd

import libfal.falcmd as falcmd
import fal_config as config
import pal_info
from fal_info import (ReqTypes,)


class FalStateMgr(falcmd.FalCmd):
    """FAL Service Control command implementation class."""

    def __init__(self, option=None):
        """Constructor."""

        falcmd.FalCmd.__init__(self, option=option)

        request_handler = lambda entry: self.send_entry(entry,
                                            pal_info.PAL_STATEMGR_PATH)

        self.set_handler(ReqTypes.QUERY, request_handler)
        self.set_handler(ReqTypes.SET, request_handler)
        self.set_handler(ReqTypes.CHANGE, request_handler)


#
# Main
#
if __name__ == "__main__":
    FalStateMgr(option=falcmd.FalCmdOption()).handle_request()
