#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""Melody Data for FalBuzzer"""


import fal_info


# バックグラウンド処理完了
BG_PROCESS_END = "r8e8r8r8r8e8r8r8r8e8r8r8r8"

# 起動完了
BOOTUP = "r2e1"

# 正常終了
OK = "r2e4"

# 異常終了
ERROR = "r2e2e2e2"

# バックアップ終了
COPYEND = BG_PROCESS_END

# リビルド完了
RAIDOK = "c8e8g8C8"

# RAID故障
RAIDFAIL = "R0r2r4e4"

# RAID崩壊
RAIDCRASH = "R0b2g2"

# UPS未接続
UPS = "R0r16c8d8e8"

# 容量警告
CAPACITY = "R0r16e8e8r2"

# FAN 温度エラー
FANERROR = "R0r2e1r2e1r2e1"

# 暗号化USB作成時
DONGLE = "r2c8r8c8r8g8r8g8r8a8r8a8r8g8r4r8f8r8f8r8e8r8e8r8d8r8d8r8c8"

# ファームウェア更新
UPDATE = "bagfedc"

# 一括登録完了
LUMPREGISTEND = BG_PROCESS_END

# フォーマット完了
FORMATEND = BG_PROCESS_END

# ブザーテスト
MELODY = "R0r2c8r8c8r8g8r8g8r8a8r8a8r8g8r8r4f8r8f8r8e8r8e8r8d8r8d8r8c8r8r4g8r8g8r8f8r8f8r8e8r8e8r8d8r8r4g8r8g8r8f8r8f8r8e8r8e8r8d8r8r4c8r8c8r8g8r8g8r8a8r8a8r8g8r8r4f8r8f8r8e8r8e8r8d8r8d8r8c8r8r4"

# セキュリティロック
LOCKMODE = "R0r2r4e4"

MELODY_TABLE = {
    fal_info.BUZZER_BOOTUP: BOOTUP,
    fal_info.BUZZER_OK: OK,
    fal_info.BUZZER_ERROR: ERROR,
    fal_info.BUZZER_COPYEND: COPYEND,
    fal_info.BUZZER_RAIDOK: RAIDOK,
    fal_info.BUZZER_RAIDFAIL: RAIDFAIL,
    fal_info.BUZZER_RAIDCRASH: RAIDCRASH,
    fal_info.BUZZER_UPS: UPS,
    fal_info.BUZZER_CAPACITY : CAPACITY,
    fal_info.BUZZER_DONGLE: DONGLE,
    fal_info.BUZZER_FANERROR: FANERROR,
    fal_info.BUZZER_MELODY: MELODY,
    fal_info.BUZZER_UPDATE: UPDATE,
    fal_info.BUZZER_LUMPREGISTEND: LUMPREGISTEND,
    fal_info.BUZZER_FORMATEND: FORMATEND,
    fal_info.BUZZER_BGPROCESSEND: BG_PROCESS_END,
    fal_info.BUZZER_BGPROCESSEND: BG_PROCESS_END,
    fal_info.BUZZER_LOCKMODE: LOCKMODE,
}

