#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

import os
import sys
import inspect

C_NAME_IDX = 0
C_INS_IDX = 1
NO_MOD_LIST = ["__init__.py"]


sys.path.append(os.path.dirname(__file__))

for mod_file in os.listdir(os.path.dirname(__file__)):
    if mod_file.endswith("pyc"):
        continue
    if mod_file in NO_MOD_LIST:
        continue

    mod_name = os.path.splitext(mod_file)[0]

    mod = __import__(mod_name, globals(), locals(), [])

    class_list = inspect.getmembers(mod, inspect.isclass)

    for c in class_list:
        locals()[c[C_NAME_IDX]] = c[C_INS_IDX]
