#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for handling LCM event"""

import os
import ionas.nascmd as nascmd
import ionas.request as request
import libevh.evhcmd as evhcmd
from iobase.cmdexec import CmdExec, NULL
from iobase.xmldata import (XmlNode)
from iobase.exception import (NotFoundError, InvalidArgError, ExecError)
from product_conf.reqinfo import (Results, ReqTypes)

SMBPASSWD = 'smbpasswd'

from pal_info import INSTALL_PATH
import sys
sys.path.append(INSTALL_PATH)
from libpal.util import RemountRoot  # FIXME 使っていい?




class EventHnadler(evhcmd.EvhCmd):
    """FAL LCM Event Hnadler command implementation class."""

    #
    # Request handlers
    #

    def __event_handler(self, entry):
        """Handle "event" request."""

        uname = entry.get().get_value('eventinfo/users/user/name', None)

        cmd = [SMBPASSWD, '-x', uname]
        with RemountRoot():
            "%(dummy_password)s\n%(dummy_password)s" % {"dummy_password": "1234"} | CmdExec([SMBPASSWD, "-sa", uname], stdout=NULL, stderr=NULL)
            CmdExec(cmd).execute(stdout=NULL, stderr=NULL)

        entry.set_result(Results.OK)
        return entry

    def __init__(self, option=None):
        """Constructor."""

        evhcmd.EvhCmd.__init__(self, option=option)

        self.set_handler(ReqTypes.EVENT, self.__event_handler)

#
# Main
#

if __name__ == "__main__":
    EventHnadler(option=evhcmd.EvhCmdOption()).handle_request()
