#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta


import libevh.evhcmd as evhcmd
from ionas.request import Entry
from fal_info import FAL_SERVICECTRL_PATH
from product_conf.reqinfo import (Results, ReqTypes)

SERVICE_XML = "<servicectrl><servicelist><service><name>%s</name>" + \
            "</service></servicelist></servicectrl>"


class EventHnadler(evhcmd.EvhCmd):

    def __request_service(self, service_name, type):
        entry = Entry(type, SERVICE_XML % service_name)
        self.send_entry(entry, FAL_SERVICECTRL_PATH)

    #
    # Request handlers
    #

    def __event_handler(self, entry):
        """Handle "event" request."""

        self.__request_service("netatalk", ReqTypes.SUSPEND)
        self.__request_service("netatalk", ReqTypes.RESUME)
        self.__request_service("avahi-daemon", ReqTypes.SUSPEND)
        self.__request_service("avahi-daemon", ReqTypes.RESUME)

        entry.set_result(Results.OK)
        return entry

    def __init__(self, option=None):
        """Constructor."""

        evhcmd.EvhCmd.__init__(self, option=option)

        self.set_handler(ReqTypes.EVENT, self.__event_handler)

#
# Main
#

if __name__ == "__main__":
    EventHnadler(option=evhcmd.EvhCmdOption()).handle_request()
