# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""EVH configuration module for LAN DISK.

Note : DO NOT EDIT.  This is automatically generated.
"""

from product_conf import *
from product_conf.devinfo import *


VERSION = "1.08.9"
LOGGER_NAME = "EVH"
LOG_FILE = NASCMD_LOG

VOLUME_STATUS_DIR = CONF_DIR + "/volume/status"

# Configuration Files
SHARES_CONF_FILE = "config-shares.xml"
SYSINFO_CONF_FILE = "config-sysinfo.xml"
LPR_SPOOL_VOL = "sataraid1"
DECODED_LOCK_KEY_FILE_PATH = TEMP_DIR + "/lkdata"

# for evh_ports
SMB_CONF_PART_DIR = CONF_DIR + "/samba"
PROFTPD_PART_DIR = CONF_DIR + "/proftpd"
PROFTPD_ANON_PART_DIR = CONF_DIR + "/proftpd_anon"
AFP_CONF_PART_DIR = CONF_DIR + "/netatalk"
RSYNCD_CONF_PART_DIR = CONF_DIR + "/rsync"
DISK_EVENT_LOCK_FILE = "disk_event_lock"

# For evh_raidrebuild and so on.
INTERNAL_VOL = STOR_IF_TO_VOL["internal"][1]
MIRROR_DEV = VOL_INFO[INTERNAL_VOL]["dev"]

INTERNAL_DEV = None
if len(INTERNAL_RAID_DEV_LIST):
    BASE_ARRY_NUM = RAID_MODE_INFO["vfsext"]["array_num"]
    for element in RAID_TO_ELEMENT[BASE_ARRY_NUM][MIRROR_DEV]:
        if element in INTERNAL_RAID_DEV_LIST:
            INTERNAL_DEV = element
            break

if MIRROR_DEV in RAID_TO_REAL_NAME:
    MIRROR_DEV = RAID_TO_REAL_NAME[MIRROR_DEV]

if INTERNAL_DEV:
    TARGET_RAID_DEV_LIST = (INTERNAL_DEV, MIRROR_DEV)
else:
    TARGET_RAID_DEV_LIST = (MIRROR_DEV,)

BOOT_COMPLETE_FILE_PATH = TEMP_DIR + "/boot_complete"
TRIED_FIRST_MOUNT_FILE_PATH = TEMP_DIR + "/tried_first_mount"

EXCLUDE_SHARE_INIT_LIST = ["usb1", "usb2", "usb3", "usb4"]

# For evh_satad_plug_unplug.
DEV_LINK_DIR = STATUS_TEMP_DIR + "/dev_link"
DEV_FILE_DIR = STATUS_TEMP_DIR + "/dev_file"

# For evh_usbd_plug_unplug.
QUICKCOPY_ARGS = [LIBEXEC_DIR + "/button/sw_handler", "--type", "func",
                    "--second", "1"]
PLUGED_LOCK_BASE = "_evh_pluged.lock"
