#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL command for handling port mode modify event"""

import libevh.evhcmd as evhcmd
from fal_info import ReqTypes
from pal_info import PAL_REPLICATION_PATH
import evh_config as config
from libevh.util import ports_event


class Ports(evhcmd.EvhCmd):
    """Port Mode Event Hnadler command implementation class."""

    def __event_handler(self, entry):
        """Handle "event" request."""

        return ports_event(entry,
            PAL_REPLICATION_PATH, config.RSYNCD_CONF_PART_DIR)

    def __init__(self, option=None):
        """Constructor."""

        evhcmd.EvhCmd.__init__(self, option=option)

        self.set_handler(ReqTypes.EVENT, self.__event_handler)

#
# Main
#

if __name__ == "__main__":
    Ports(option=evhcmd.EvhCmdOption()).handle_request()
