#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from ionas.request import Request, Entry
from fal_info import FAL_EVENTLOG_PATH, ReqTypes
from product_conf import SUDO_CMD
import sys

ENTRY_XML_FMT = """<eventlog>
        <log>
            <code>%s</code>
            <arglist>%s</arglist>
        </log>
    </eventlog>"""
ARG_XML_FMT = "<arg name='%s'>%s</arg>"


class SetLog():

    HELP = """Usage...
  first arg is log_code.
  after args is "arg=value".

  Ex.
    setlog 1234 sharename=disk1 username=user1"""

    def _request(self, entrylist, fal=FAL_EVENTLOG_PATH):
        request = Request(fal, filter_cmd=SUDO_CMD)
        response = request.request(entrylist)
        return response
   
    def set(self, code, arg_list):

        entry = Entry(ReqTypes.ADD, ENTRY_XML_FMT % (code, "".join(
            [ARG_XML_FMT % tuple(arg.split("=", 1)) for arg in arg_list])))
        return self._request(entry).get_entrylist().get_entry()


if __name__ == "__main__":

    try:
        if sys.argv[1] == "--help":
            print SetLog.HELP
            exit(0)

        code = sys.argv[1]

        arg_list = []

        if len(sys.argv) > 2:
            arg_list = argv[2:]

        setlog = SetLog()
        setlog.set(code, arg_list)

    except:
        exit(1)
