# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL commands information module.

Note : DO NOT EDIT.  This is automatically generated.
"""

import locale


import iobase.xmldata as xmldata
import ionas.request as request
import fal_info
from fal_info import ReqTypes

try:
    from msgconf import (IGNORE_CATEGORY_LIST,)
except:
    IGNORE_CATEGORY_LIST = []


_MESSAGE_CODE_UNIT = 10000
_CATEGORY_CODE_UNIT = 100
_LOCALE_MAP = {"": "", "ja_JP": "ja"}
_MESSAGEINFO_PATH = "messageinfo"
_CODE_PATH = _MESSAGEINFO_PATH + "/code"
_ARGLIST_NAME = "arglist"
_ARG_NAME = "arg"
_NAME_NAME = "name"

_CATEGORY_LIST = (
        "200",
        "300",
        "400",
        "500",
        "600",
        "700",
        "800",
        "900",
        "1000",
        "1100",
        "1200",
        "1300",
        "1400",
        "1500",
        "1600",
        "1700",
        "1800",
        "1900",
        "2000",
        "2100",
        "2200",
        "2300",
        "2400",
        "2500",
        "2600",
        "2700",
        "2800",
        "2900",
        "3000",
        "3100",
        "3200",
        "3300",
        "3400",
        "3500",
        "3600",
        "3700",
        "3800",
        "3900",
        "4000",
        "4100",
        "4200",
        "4300",
        "4400",
        "5000",
    )


_CATEGORY_STR_LIST_DICT = {
        "": {
                "2900": "Periodic Notice",
                "1300": "Microsoft Network",
                "600": "LAN2",
                "700": "Administrator",
                "1200": "Capacity",
                "4100": "System",
                "4300": "System Initialization",
                "3000": "SNMP",
                "3900": "Announce",
                "2800": "Report",
                "3700": "Firmware",
                "1900": "RAID Volume",
                "2200": "Active Repair",
                "4000": "Proxy",
                "2300": "Lock Key",
                "3100": "NarSuS",
                "0": "Unknown",
                "1500": "Backup",
                "3300": "Button",
                "2400": "UPS",
                "400": "Network",
                "1400": "Lump Registration",
                "500": "LAN1",
                "2500": "Printer",
                "200": "Name Setting",
                "3600": "Package",
                "2600": "Service",
                "4200": "Temperature/FAN",
                "300": "Date & Time",
                "2700": "Mail",
                "3800": "Log",
                "3400": "Lamp",
                "100": "Validation",
                "1700": "QuickCopy",
                "900": "Group",
                "800": "User Management",
                "5000": "LCM Display",
                "1800": "RAID",
                "3500": "Ecology",
                "1600": "Data Copy",
                "3200": "Power",
                "4400": "Tools",
                "2000": "Volume",
                "1100": "Quota",
                "2100": "Disk",
                "1000": "Share",
            },
        "ja": {
                "2900": "定期通知",
                "1300": "Microsoftネットワーク",
                "600": "LAN2",
                "700": "管理者",
                "1200": "ボリューム使用量",
                "4100": "システム",
                "4300": "システム初期化",
                "3000": "SNMP",
                "3900": "お知らせ",
                "2800": "定期レポート",
                "3700": "ファームウェア",
                "1900": "RAIDボリューム",
                "2200": "アクティブリペア",
                "4000": "プロキシ",
                "2300": "ロックキー",
                "3100": "NarSuS",
                "0": "不明",
                "1500": "バックアップ",
                "3300": "ボタン",
                "2400": "UPS",
                "400": "ネットワーク",
                "1400": "一括登録",
                "500": "LAN1",
                "2500": "プリンター",
                "200": "名前設定",
                "3600": "パッケージ",
                "2600": "サービス",
                "4200": "温度・FAN",
                "300": "日付と時刻",
                "2700": "メール",
                "3800": "ログ",
                "3400": "ランプ",
                "100": "入力確認",
                "1700": "クイックコピー",
                "900": "グループ",
                "800": "ユーザー",
                "5000": "LCM表示",
                "1800": "RAID",
                "3500": "省電力",
                "1600": "データコピー",
                "3200": "電源",
                "4400": "ツール",
                "2000": "ボリューム",
                "1100": "使用量制限",
                "2100": "ディスク",
                "1000": "共有",
            },
    }


class Cat:
    """Class for defining the message category variables."""

    UNKNOWN = "0"
    VALIDATE = "100"
    LANDISK_NAME = "200"
    DATE = "300"
    NETWORK = "400"
    LAN1_NET = "500"
    LAN2_NET = "600"
    ADMIN = "700"
    USER = "800"
    GROUP = "900"
    SHARE = "1000"
    QUOTA = "1100"
    CAPACITY = "1200"
    MS_NET = "1300"
    LUMP_REG = "1400"
    BACKUP = "1500"
    DATACOPY = "1600"
    QUICKCOPY = "1700"
    RAID = "1800"
    RAID_VOLUME = "1900"
    VOLUME = "2000"
    DISK = "2100"
    ACTIVE_REPAIR = "2200"
    LOCKKEY = "2300"
    UPS = "2400"
    PRINTER = "2500"
    SERVICE = "2600"
    MAIL = "2700"
    REPORT = "2800"
    PERIODIC = "2900"
    SNMP = "3000"
    NARSUS = "3100"
    POWER = "3200"
    SWITCH = "3300"
    LAMP = "3400"
    ECO = "3500"
    PKG = "3600"
    FIRMWARE = "3700"
    LOG = "3800"
    ANNOUNCE = "3900"
    PROXY = "4000"
    SYSTEM = "4100"
    TEMP_FAN = "4200"
    SYS_INIT = "4300"
    TOOLS = "4400"
    LCM = "5000"


class Msg:
    """Class for defining the message variables."""

    ERR_VALIDATE_NOT_NULL = "1010000"
    ERR_VALIDATE_NOT_BEGIN_HYPHEN = "1010001"
    ERR_VALIDATE_NOT_NUMBER_ONLY = "1010002"
    ERR_VALIDATE_IN_LENGTH_RANGE = "1010003"
    ERR_VALIDATE_IN_COUNT_RANGE = "1010004"
    ERR_VALIDATE_FORMAT = "1010005"
    ERR_VALIDATE_NOT_BEGIN_QUOTE = "1010006"
    ERR_VALIDATE_NOT_END_QUOTE = "1010007"
    ERR_VALIDATE_NOT_END_DOLLER = "1010008"
    ERR_VALIDATE_NOT_BEGIN_SHARP = "1010009"
    ERR_VALIDATE_NOT_BEGIN_SPACE = "1010010"
    ERR_VALIDATE_NOT_END_SPACE = "1010011"
    ERR_VALIDATE_NOT_MULTI_SPACE = "1010012"
    ERR_VALIDATE_NOT_DUPLICATE = "1010013"
    ERR_VALIDATE_NOT_UPLOW = "1010014"
    ERR_VALIDATE_HOST_LAN1_LAN2_DUPLICATE = "1010015"
    ERR_VALIDATE_BEGIN_CHAR = "1010016"
    ERR_VALIDATE_USABLE = "1010017"
    ERR_VALIDATE_IN_ITEM = "1010018"
    ERR_VALIDATE_NOT_END_HYPHEN = "1010019"
    ERR_VALIDATE_NUMERIC = "1010020"
    ERR_VALIDATE_NOT_DUPLICATE = "1010021"
    ERR_VALIDATE_IN_RANGE = "1010022"
    ERR_VALIDATE_IN_SINGLE_MULTI_BYTE_LENGTH_RANGE = "1010023"
    ERR_VALIDATE_NOT_BEGIN_DOT = "1010024"
    ERR_VALIDATE_HOST_LAN1_DUPLICATE = "1010025"
    MSG_LANDISK_NAME_CHANGE = "2000000"
    ERR_LANDISK_NAME_STATE_CHANGE = "2030000"
    ERR_LANDISK_NAME_CHANGE = "2040000"
    MSG_DATE_CHANGE = "3000000"
    MSG_DATE_NTP_SYNC_DONE = "3000001"
    ERR_DATE_STATE_CHANGE = "3030000"
    ERR_DATE_CHANGE = "3040000"
    ERR_DATE_NTP_SYNC = "3090000"
    MSG_NET_CHANGE = "4000000"
    ERR_NET_STATE_CHANGE = "4030000"
    ERR_NET_CHANGE = "4040000"
    MSG_LAN1_NET_DHCP_GET_IP = "5000000"
    MSG_LAN1_NET_LINK_UP = "5000001"
    MSG_LAN1_NET_LINK_DOWN = "5080000"
    ERR_LAN1_NET_DHCP_GET_IP = "5090000"
    MSG_LAN2_NET_DHCP_GET_IP = "6000000"
    MSG_LAN2_NET_LINK_UP = "6000001"
    MSG_LAN2_NET_LINK_DOWN = "6080000"
    ERR_LAN2_NET_DHCP_GET_IP = "6090000"
    MSG_ADMIN_CHANGE = "7000000"
    ERR_ADMIN_STATE_CHANGE = "7030000"
    ERR_ADMIN_CHANGE = "7040000"
    MSG_USER_PASSWORD_CHANGE = "8000000"
    MSG_USER_ADD = "8000001"
    MSG_USER_DELETE = "8000002"
    MSG_USER_INFO_CHANGE = "8000003"
    ERR_USER_STATE_CHANGE = "8030000"
    ERR_USER_PASSWORD_CHANGE = "8040000"
    ERR_USER_ADD = "8040001"
    ERR_USER_DELETE = "8040002"
    ERR_USER_INFO_CHANGE = "8040003"
    ERR_USER_ALREADY_EXIST = "8040004"
    ERR_USER_NOT_EXIST = "8040005"
    ERR_USER_NO_MORE = "8040006"
    MSG_GROUP_ADD = "9000000"
    MSG_GROUP_DELETE = "9000001"
    MSG_GROUP_INFO_CHANGE = "9000002"
    ERR_GROUP_STATE_CHANGE = "9030000"
    ERR_GROUP_ADD = "9040000"
    ERR_GROUP_DELETE = "9040001"
    ERR_GROUP_INFO_CHANGE = "9040002"
    ERR_GROUP_ALREADY_EXIST = "9040003"
    ERR_GROUP_NOT_EXIST = "9040004"
    ERR_GROUP_NO_MORE = "9040005"
    MSG_SHARE_ADD = "10000000"
    MSG_SHARE_DELETE = "10000001"
    MSG_SHARE_INFO_CHANGE = "10000002"
    ERR_SHARE_STATE_CHANGE = "10030000"
    ERR_SHARE_ADD = "10040000"
    ERR_SHARE_DELETE = "10040001"
    ERR_SHARE_INFO_CHANGE = "10040002"
    ERR_SHARE_ALREADY_EXIST = "10040003"
    ERR_SHARE_NOT_EXIST = "10040004"
    ERR_SHARE_NO_MORE = "10040005"
    MSG_QUOTA_CHANGE = "11000000"
    MSG_QUOTA_CHECK_OK = "11000001"
    ERR_QUOTA_STATE_CHANGE = "11030000"
    ERR_QUOTA_CHANGE = "11040000"
    ERR_QUOTA_SECURITY_LOCK_MODE = "11040001"
    ERR_QUOTA_ERROR = "11040002"
    ERR_QUOTA_RAID_CRASH = "11040003"
    ERR_QUOTA_OVER = "11100000"
    ERR_QUOTA_USER_OVER = "11100001"
    ERR_QUOTA_GROUP_OVER = "11100002"
    ERR_QUOTA_SHARE_OVER = "11100003"
    ERR_QUOTA_DOMAIN_USER_OVER = "11100004"
    ERR_QUOTA_DOMAIN_GROUP_OVER = "11100005"
    MSG_CAPACITY_CHECK_OK = "12000000"
    ERR_CAPACITY_SECURITY_LOCK_MODE = "12040000"
    ERR_CAPACITY_ERROR = "12040001"
    ERR_CAPACITY_RAID_CRASH = "12040002"
    ERR_CAPACITY_OVER = "12100000"
    MSG_MS_NET_CHANGE = "13000000"
    ERR_MS_NET_STATE_CHANGE = "13030001"
    ERR_MS_NET_CHANGE = "13040000"
    MSG_LUMP_REG_START = "14000000"
    MSG_LUMP_REG_COMPLETE = "14000001"
    ERR_LUMP_REG_STATE_CHANGE = "14030000"
    ERR_LUMP_REG_FILE_SIZE_OVER = "14060000"
    ERR_LUMP_REG_INVALID_FILE = "14060001"
    ERR_LUMP_REG_INVALID_ITEM = "14070000"
    ERR_LUMP_REG_INVALID_FIELD = "14070001"
    ERR_LUMP_REG_NOT_SET = "14070002"
    MSG_BACKUP_ADD = "15000000"
    MSG_BACKUP_DELETE = "15000001"
    MSG_BACKUP_MODIFY = "15000002"
    MSG_BACKUP_START = "15000010"
    MSG_BACKUP_EXEC_START = "15000011"
    MSG_BACKUP_COMPLETE = "15000012"
    MSG_BACKUP_QUEUE = "15000013"
    MSG_BACKUP_JOB_START = "15000014"
    MSG_BACKUP_JOB_COMPLETE = "15000015"
    MSG_BACKUP_SOURCE_START = "15000016"
    MSG_BACKUP_SOURCE_COMPLETE = "15000017"
    MSG_BACKUP_JOB_START_FULL = "15000018"
    MSG_BACKUP_JOB_START_DIFF = "15000019"
    MSG_BACKUP_EXEC_STOP = "15000020"
    MSG_BACKUP_JOB_STOP = "15000021"
    MSG_BACKUP_COMPLETE_WITH_STOP = "15000022"
    MSG_BACKUP_RESTORE_JOB_STOP = "15000023"
    MSG_BACKUP_RESTORE_START = "15000030"
    MSG_BACKUP_RESTORE_COMPLETE = "15000031"
    MSG_BACKUP_RESTORE_QUEUE = "15000032"
    MSG_BACKUP_RESTORE_JOB_START = "15000033"
    MSG_BACKUP_RESTORE_JOB_COMPLETE = "15000034"
    MSG_BACKUP_RESTORE_SOURCE_START = "15000035"
    MSG_BACKUP_RESTORE_SOURCE_COMPLETE = "15000036"
    ERR_BACKUP_STATE_CHANGE = "15030000"
    ERR_BACKUP_BG_STATE_CHANGE = "15030001"
    ERR_BACKUP_ADD = "15040000"
    ERR_BACKUP_DELETE = "15040001"
    ERR_BACKUP_MODIFY = "15040002"
    ERR_BACKUP_JOB_NO_MORE = "15040003"
    ERR_BACKUP_NO_SOURCE = "15040010"
    ERR_BACKUP_INVALID_FORMAT = "15040011"
    ERR_BACKUP_INVALID_SHARE = "15040012"
    ERR_BACKUP_VOLUME_NOT_MOUNTED = "15040013"
    ERR_BACKUP_NOT_EXIST_SHARE = "15040014"
    ERR_BACKUP_CONNECT = "15040015"
    ERR_BACKUP_PERMISSION_DENIED = "15040016"
    ERR_BACKUP_NO_SPACE = "15040017"
    ERR_BACKUP_OPERATION = "15040018"
    ERR_BACKUP_SOURCE = "15040019"
    ERR_BACKUP_JOB = "15040020"
    ERR_BACKUP_CREATE_LOG_FILE = "15040030"
    ERR_BACKUP_RESTORE_OPERATION = "15040031"
    ERR_BACKUP_RESTORE_INVALID_SHARE = "15040032"
    ERR_BACKUP_RESTORE_INVALID_FORMAT = "15040033"
    ERR_BACKUP_RESTORE_VOLUME_NOT_MOUNTED = "15040034"
    ERR_BACKUP_RESTORE_NOT_EXIST_SHARE = "15040035"
    ERR_BACKUP_RESTORE_CONNECT = "15040036"
    ERR_BACKUP_RESTORE_PERMISSION_DENIED = "15040037"
    ERR_BACKUP_RESTORE_NO_SPACE = "15040038"
    ERR_BACKUP_RESTORE_SOURCE = "15040039"
    ERR_BACKUP_RESTORE_JOB = "15040040"
    ERR_BACKUP_EXEC_STOP = "15040041"
    ERR_BACKUP_JOB_STOP = "15040042"
    ERR_BACKUP_EXEC_STOP = "15040043"
    ERR_BACKUP_RESTORE_JOB_STOP = "15040044"
    MSG_DATACOPY_ADD = "16000000"
    MSG_DATACOPY_DELETE = "16000001"
    MSG_DATACOPY_MODIFY = "16000002"
    MSG_DATACOPY_START = "16000010"
    MSG_DATACOPY_EXEC_START = "16000011"
    MSG_DATACOPY_COMPLETE = "16000012"
    MSG_DATACOPY_QUEUE = "16000013"
    MSG_DATACOPY_JOB_START = "16000014"
    MSG_DATACOPY_JOB_COMPLETE = "16000015"
    MSG_DATACOPY_EXEC_STOP = "16000016"
    MSG_DATACOPY_JOB_STOP = "16000017"
    MSG_DATACOPY_COMPLETE_WITH_STOP = "16000018"
    ERR_DATACOPY_STATE_CHANGE = "16030000"
    ERR_DATACOPY_BG_STATE_CHANGE = "16030001"
    ERR_DATACOPY_ADD = "16040000"
    ERR_DATACOPY_DELETE = "16040001"
    ERR_DATACOPY_MODIFY = "16040002"
    ERR_DATACOPY_JOB_NO_MORE = "16040003"
    ERR_DATACOPY_NO_SOURCE = "16040010"
    ERR_DATACOPY_INVALID_FORMAT = "16040011"
    ERR_DATACOPY_INVALID_SHARE = "16040012"
    ERR_DATACOPY_VOLUME_NOT_MOUNTED = "16040013"
    ERR_DATACOPY_NOT_EXIST_SHARE = "16040014"
    ERR_DATACOPY_CONNECT = "16040015"
    ERR_DATACOPY_PERMISSION_DENIED = "16040016"
    ERR_DATACOPY_NO_SPACE = "16040017"
    ERR_DATACOPY_OPERATION = "16040018"
    ERR_DATACOPY_JOB = "16040019"
    ERR_DATACOPY_EXEC_STOP = "16040020"
    ERR_DATACOPY_JOB_STOP = "16040021"
    MSG_QUICKCOPY_START = "17000000"
    MSG_QUICKCOPY_COMPLETE = "17000001"
    ERR_QUICKCOPY_STATE_CHANGE = "17030000"
    ERR_QUICKCOPY_OPERATION = "17040000"
    ERR_QUICKCOPY_INVALID_SHARE = "17040001"
    ERR_QUICKCOPY_VOLUME_NOT_MOUNTED = "17040002"
    ERR_QUICKCOPY_NOT_EXIST_SHARE = "17040003"
    ERR_QUICKCOPY_NO_SPACE = "17040004"
    ERR_QUICKCOPY_INVALID_FORMAT = "17040005"
    MSG_RAID_FORCE_START = "18000001"
    MSG_RAID_RECOVER = "18000002"
    MSG_RAID_MIRROR_START_FROM_USB3 = "18000003"
    MSG_RAID_MIRROR_START_TO_USB3 = "18000004"
    MSG_RAID_USB3_VFSEXT_START = "18000005"
    MSG_RAID_USB4_VFSEXT_START = "18000006"
    MSG_RAID_MIRROR_START_FROM_USB2 = "18000007"
    MSG_RAID_MIRROR_START_TO_USB2 = "18000008"
    MSG_RAID_INTERNAL_REBUILD_START = "18000010"
    MSG_RAID_INTERNAL_REBUILD_PROGRESS = "18000011"
    MSG_RAID_INTERNAL_REBUILD_END = "18000012"
    MSG_RAID_MIRROR_REBUILD_START = "18000020"
    MSG_RAID_MIRROR_REBUILD_PROGRESS = "18000021"
    MSG_RAID_MIRROR_REBUILD_END = "18000022"
    MSG_RAID_MODE_CHANGE_RAID6 = "18000030"
    MSG_RAID_MODE_CHANGE_RAID5 = "18000031"
    MSG_RAID_MODE_CHANGE_RAID0 = "18000032"
    MSG_RAID_MODE_CHANGE_VFSEXT = "18000033"
    MSG_RAID_MODE_CHANGE = "18000034"
    MSG_RAID_MODE_CHANGE_RAID1 = "18000035"
    MSG_RAID_MODE_CHANGE_VFSEXT_6 = "18000036"
    MSG_RAID_MODE_CHANGE_VFSEXT_5 = "18000037"
    MSG_RAID_MODE_CHANGE_VFSEXT_4 = "18000038"
    MSG_RAID_MODE_CHANGE_VFSEXT_3 = "18000040"
    MSG_RAID_MODE_CHANGE_VFSEXT_2 = "18000041"
    MSG_RAID_MODE_CHANGE_VFSEXT_1 = "18000042"
    MSG_RAID_MODE_CHANGE_RAID6_6 = "18000043"
    MSG_RAID_MODE_CHANGE_RAID6_5 = "18000044"
    MSG_RAID_MODE_CHANGE_RAID6_4 = "18000045"
    MSG_RAID_MODE_CHANGE_RAID6_3 = "18000046"
    MSG_RAID_MODE_CHANGE_RAID6_2 = "18000047"
    MSG_RAID_MODE_CHANGE_RAID6_1 = "18000048"
    MSG_RAID_MODE_CHANGE_RAID5_6 = "18000049"
    MSG_RAID_MODE_CHANGE_RAID5_5 = "18000050"
    MSG_RAID_MODE_CHANGE_RAID5_4 = "18000051"
    MSG_RAID_MODE_CHANGE_RAID5_3 = "18000052"
    MSG_RAID_MODE_CHANGE_RAID5_2 = "18000053"
    MSG_RAID_MODE_CHANGE_RAID5_1 = "18000054"
    MSG_RAID_MODE_CHANGE_RAID1_6 = "18000055"
    MSG_RAID_MODE_CHANGE_RAID1_5 = "18000056"
    MSG_RAID_MODE_CHANGE_RAID1_4 = "18000057"
    MSG_RAID_MODE_CHANGE_RAID1_3 = "18000058"
    MSG_RAID_MODE_CHANGE_RAID1_2 = "18000059"
    MSG_RAID_MODE_CHANGE_RAID1_1 = "18000060"
    MSG_RAID_MODE_CHANGE_RAID0_6 = "18000061"
    MSG_RAID_MODE_CHANGE_RAID0_5 = "18000062"
    MSG_RAID_MODE_CHANGE_RAID0_4 = "18000063"
    MSG_RAID_MODE_CHANGE_RAID0_3 = "18000064"
    MSG_RAID_MODE_CHANGE_RAID0_2 = "18000065"
    MSG_RAID_MODE_CHANGE_RAID0_1 = "18000066"
    MSG_RAID_CHANGE = "18000070"
    MSG_RAID_MODE_EXTEND_VFSEXT_6 = "18000100"
    MSG_RAID_MODE_AUTO_EXTEND_VFSEXT_6 = "18000120"
    ERR_RAID_FORCE_START = "18040001"
    ERR_RAID_MIRROR_START_FROM_USB3 = "18040002"
    ERR_RAID_MIRROR_START_TO_USB3 = "18040003"
    ERR_RAID_MIRROR_CAP_SHORTAGE_USB3 = "18040004"
    ERR_RAID_MIRROR_WAITING_USB3 = "18040005"
    ERR_RAID_MIRROR_FAIL_USB3 = "18040006"
    ERR_RAID_MIRROR_START_FROM_USB2 = "18040007"
    ERR_RAID_MIRROR_START_TO_USB2 = "18040008"
    ERR_RAID_MIRROR_CAP_SHORTAGE_USB2 = "18040009"
    ERR_RAID_MIRROR_WAITING_USB2 = "18040010"
    ERR_RAID_MIRROR_FAIL_USB2 = "18040011"
    ERR_RAID_MODE_CHANGE_RAID6 = "18040030"
    ERR_RAID_MODE_CHANGE_RAID5 = "18040031"
    ERR_RAID_MODE_CHANGE_RAID0 = "18040032"
    ERR_RAID_MODE_CHANGE_VFSEXT = "18040033"
    ERR_RAID_MODE_CHANGE_DIVICE_NOT_FOUND = "18040034"
    ERR_RAID_MODE_CHANGE_RAID1 = "18040035"
    ERR_RAID_MODE_CHANGE = "18040036"
    ERR_RAID_MODE_CHANGE_VFSEXT_6 = "18040041"
    ERR_RAID_MODE_CHANGE_VFSEXT_5 = "18040042"
    ERR_RAID_MODE_CHANGE_VFSEXT_4 = "18040043"
    ERR_RAID_MODE_CHANGE_VFSEXT_3 = "18040044"
    ERR_RAID_MODE_CHANGE_VFSEXT_2 = "18040045"
    ERR_RAID_MODE_CHANGE_VFSEXT_1 = "18040046"
    ERR_RAID_MODE_CHANGE_RAID6_6 = "18040051"
    ERR_RAID_MODE_CHANGE_RAID6_5 = "18040052"
    ERR_RAID_MODE_CHANGE_RAID6_4 = "18040053"
    ERR_RAID_MODE_CHANGE_RAID5_6 = "18040061"
    ERR_RAID_MODE_CHANGE_RAID5_5 = "18040062"
    ERR_RAID_MODE_CHANGE_RAID5_4 = "18040063"
    ERR_RAID_MODE_CHANGE_RAID5_3 = "18040064"
    ERR_RAID_MODE_CHANGE_RAID1_6 = "18040071"
    ERR_RAID_MODE_CHANGE_RAID1_5 = "18040072"
    ERR_RAID_MODE_CHANGE_RAID1_4 = "18040073"
    ERR_RAID_MODE_CHANGE_RAID1_3 = "18040074"
    ERR_RAID_MODE_CHANGE_RAID1_2 = "18040075"
    ERR_RAID_MODE_CHANGE_RAID1_1 = "18040076"
    ERR_RAID_MODE_CHANGE_RAID0_6 = "18040081"
    ERR_RAID_MODE_CHANGE_RAID0_5 = "18040082"
    ERR_RAID_MODE_CHANGE_RAID0_4 = "18040083"
    ERR_RAID_MODE_CHANGE_RAID0_3 = "18040084"
    ERR_RAID_MODE_CHANGE_RAID0_2 = "18040085"
    ERR_RAID_MODE_CHANGE_RAID0_1 = "18040086"
    ERR_RAID_CHANGE = "18040090"
    ERR_RAID_MODE_EXTEND_VFSEXT_6 = "18040100"
    ERR_RAID_MODE_AUTO_EXTEND_VFSEXT_6 = "18040120"
    ERR_RAID_CRASH = "18100000"
    ERR_RAID_DEGRADE = "18100001"
    ERR_RAID_FAIL = "18100002"
    ERR_RAID_USB3_VFSEXT_START = "18100023"
    ERR_RAID_USB3_VFSEXT_CAP_SHORTAGE = "18100024"
    ERR_RAID_USB3_VFSEXT_WAITING = "18100025"
    ERR_RAID_USB3_VFSEXT_FAIL = "18100026"
    ERR_RAID_USB4_VFSEXT_START = "18100033"
    ERR_RAID_USB4_VFSEXT_CAP_SHORTAGE = "18100034"
    ERR_RAID_USB4_VFSEXT_WAITING = "18100035"
    ERR_RAID_USB4_VFSEXT_FAIL = "18100036"
    MSG_RAID_VOLUME_MOUNT = "19000000"
    ERR_RAID_VOLUME_MOUNT = "19040000"
    MSG_VOLUME_MODE_CHANGE = "20000000"
    MSG_VOLUME_MODE_CHANGE_MIRROR_START = "20000001"
    MSG_VOLUME_MODE_CHANGE_MIRROR_CAP_SHORTAGE_USB3 = "20000002"
    MSG_VOLUME_MODE_CHANGE_MIRROR_NOT_CONNECTED_USB3 = "20000003"
    MSG_VOLUME_MODE_CHANGE_MIRROR_WAITING_USB3 = "20000004"
    MSG_VOLUME_MODE_CHANGE_MIRROR_FAIL_USB3 = "20000005"
    MSG_VOLUME_MODE_CHANGE_MIRROR_HOLD = "20000006"
    MSG_VOLUME_MIRROR_REMOVE_START = "20000007"
    MSG_VOLUME_MODE_CHANGE_VFSEXT_START = "20000008"
    MSG_VOLUME_MODE_CHANGE_VFSEXT_CAP_SHORTAGE = "20000009"
    MSG_VOLUME_MODE_CHANGE_VFSEXT_NOT_CONNECTED = "20000010"
    MSG_VOLUME_MODE_CHANGE_VFSEXT_WAITING = "20000011"
    MSG_VOLUME_MODE_CHANGE_VFSEXT_FAIL = "20000012"
    MSG_VOLUME_MODE_CHANGE_VFSEXT_HOLD = "20000013"
    MSG_VOLUME_MODE_CHANGE_MIRROR_CAP_SHORTAGE_USB2 = "20000014"
    MSG_VOLUME_MODE_CHANGE_MIRROR_NOT_CONNECTED_USB2 = "20000015"
    MSG_VOLUME_MODE_CHANGE_MIRROR_WAITING_USB2 = "20000016"
    MSG_VOLUME_MODE_CHANGE_MIRROR_FAIL_USB2 = "20000017"
    MSG_VOLUME_INTERNAL_FORMAT_START = "20000020"
    MSG_VOLUME_INTERNAL_FORMAT = "20000021"
    MSG_VOLUME_INTERNAL_CHECKDISK_START = "20000022"
    MSG_VOLUME_INTERNAL_CHECKDISK = "20000023"
    MSG_VOLUME_USB1_FORMAT_START = "20000110"
    MSG_VOLUME_USB1_FORMAT = "20000111"
    MSG_VOLUME_USB1_CHECKDISK_START = "20000112"
    MSG_VOLUME_USB1_CHECKDISK = "20000113"
    MSG_VOLUME_USB1_MOUNT = "20000114"
    MSG_VOLUME_USB1_UNMOUNT = "20000115"
    MSG_VOLUME_USB2_FORMAT_START = "20000120"
    MSG_VOLUME_USB2_FORMAT = "20000121"
    MSG_VOLUME_USB2_CHECKDISK_START = "20000122"
    MSG_VOLUME_USB2_CHECKDISK = "20000123"
    MSG_VOLUME_USB2_MOUNT = "20000124"
    MSG_VOLUME_USB2_UNMOUNT = "20000125"
    MSG_VOLUME_USB3_FORMAT_START = "20000130"
    MSG_VOLUME_USB3_FORMAT = "20000131"
    MSG_VOLUME_USB3_CHECKDISK_START = "20000132"
    MSG_VOLUME_USB3_CHECKDISK = "20000133"
    MSG_VOLUME_USB3_MOUNT = "20000134"
    MSG_VOLUME_USB3_UNMOUNT = "20000135"
    MSG_VOLUME_USB4_FORMAT_START = "20000140"
    MSG_VOLUME_USB4_FORMAT = "20000141"
    MSG_VOLUME_USB4_CHECKDISK_START = "20000142"
    MSG_VOLUME_USB4_CHECKDISK = "20000143"
    MSG_VOLUME_USB4_MOUNT = "20000144"
    MSG_VOLUME_USB4_UNMOUNT = "20000145"
    ERR_VOLUME_STATE_CHANGE = "20030000"
    ERR_VOLUME_MODE_CHANGE = "20040000"
    ERR_VOLUME_INTERNAL_FORMAT = "20040020"
    ERR_VOLUME_INTERNAL_CHECKDISK = "20040021"
    ERR_VOLUME_USB1_FORMAT = "20040110"
    ERR_VOLUME_USB1_CHECKDISK = "20040111"
    ERR_VOLUME_USB1_MOUNT = "20040112"
    ERR_VOLUME_USB1_UNMOUNT = "20040113"
    ERR_VOLUME_USB2_FORMAT = "20040120"
    ERR_VOLUME_USB2_CHECKDISK = "20040121"
    ERR_VOLUME_USB2_MOUNT = "20040122"
    ERR_VOLUME_USB2_UNMOUNT = "20040123"
    ERR_VOLUME_USB3_FORMAT = "20040130"
    ERR_VOLUME_USB3_CHECKDISK = "20040131"
    ERR_VOLUME_USB3_MOUNT = "20040132"
    ERR_VOLUME_USB3_UNMOUNT = "20040133"
    ERR_VOLUME_USB4_FORMAT = "20040140"
    ERR_VOLUME_USB4_CHECKDISK = "20040141"
    ERR_VOLUME_USB4_MOUNT = "20040142"
    ERR_VOLUME_USB4_UNMOUNT = "20040143"
    ERR_VOLUME_USB1_UNFORMATTED = "20100110"
    ERR_VOLUME_USB1_CHECKDISK_NOT_SUPPORTED = "20100111"
    ERR_VOLUME_USB2_UNFORMATTED = "20100120"
    ERR_VOLUME_USB2_CHECKDISK_NOT_SUPPORTED = "20100121"
    ERR_VOLUME_USB3_UNFORMATTED = "20100130"
    ERR_VOLUME_USB3_CHECKDISK_NOT_SUPPORTED = "20100131"
    ERR_VOLUME_USB4_UNFORMATTED = "20100140"
    ERR_VOLUME_USB4_CHECKDISK_NOT_SUPPORTED = "20100141"
    MSG_DISK_SATA1_PLUG = "21000010"
    MSG_DISK_SATA1_UNPLUG = "21000011"
    MSG_DISK_SATA1_REMOVE = "21000012"
    MSG_DISK_SATA2_PLUG = "21000020"
    MSG_DISK_SATA2_UNPLUG = "21000021"
    MSG_DISK_SATA2_REMOVE = "21000022"
    MSG_DISK_SATA3_PLUG = "21000030"
    MSG_DISK_SATA3_UNPLUG = "21000031"
    MSG_DISK_SATA3_REMOVE = "21000032"
    MSG_DISK_SATA4_PLUG = "21000040"
    MSG_DISK_SATA4_UNPLUG = "21000041"
    MSG_DISK_SATA4_REMOVE = "21000042"
    MSG_DISK_SATA5_PLUG = "21000050"
    MSG_DISK_SATA5_UNPLUG = "21000051"
    MSG_DISK_SATA5_REMOVE = "21000052"
    MSG_DISK_SATA6_PLUG = "21000060"
    MSG_DISK_SATA6_UNPLUG = "21000061"
    MSG_DISK_SATA6_REMOVE = "21000062"
    MSG_DISK_USB1_PLUG = "21000110"
    MSG_DISK_USB1_UNPLUG = "21000111"
    MSG_DISK_USB1_REMOVE = "21000112"
    MSG_DISK_USB2_PLUG = "21000120"
    MSG_DISK_USB2_UNPLUG = "21000121"
    MSG_DISK_USB2_REMOVE = "21000122"
    MSG_DISK_USB3_PLUG = "21000130"
    MSG_DISK_USB3_UNPLUG = "21000131"
    MSG_DISK_USB3_REMOVE = "21000132"
    MSG_DISK_USB4_PLUG = "21000140"
    MSG_DISK_USB4_UNPLUG = "21000141"
    MSG_DISK_USB4_REMOVE = "21000142"
    ERR_DISK_SATA1_DETECT_ERROR = "21080010"
    ERR_DISK_SATA1_CAP_SHORTAGE = "21080011"
    ERR_DISK_SATA1_FAIL = "21080012"
    ERR_DISK_SATA1_REMOVE = "21080013"
    ERR_DISK_SATA1_REMOVE_RAID_FAIL = "21080014"
    ERR_DISK_SATA1_REMOVE_RAID_DEGRADE = "21080015"
    ERR_DISK_SATA1_REMOVE_RAID_CRASH = "21080016"
    ERR_DISK_SATA2_DETECT_ERROR = "21080020"
    ERR_DISK_SATA2_CAP_SHORTAGE = "21080021"
    ERR_DISK_SATA2_FAIL = "21080022"
    ERR_DISK_SATA2_REMOVE = "21080023"
    ERR_DISK_SATA2_REMOVE_RAID_FAIL = "21080024"
    ERR_DISK_SATA2_REMOVE_RAID_DEGRADE = "21080025"
    ERR_DISK_SATA2_REMOVE_RAID_CRASH = "21080026"
    ERR_DISK_SATA3_DETECT_ERROR = "21080030"
    ERR_DISK_SATA3_CAP_SHORTAGE = "21080031"
    ERR_DISK_SATA3_FAIL = "21080032"
    ERR_DISK_SATA3_REMOVE = "21080033"
    ERR_DISK_SATA3_REMOVE_RAID_FAIL = "21080034"
    ERR_DISK_SATA3_REMOVE_RAID_DEGRADE = "21080035"
    ERR_DISK_SATA3_REMOVE_RAID_CRASH = "21080036"
    ERR_DISK_SATA4_DETECT_ERROR = "21080040"
    ERR_DISK_SATA4_CAP_SHORTAGE = "21080041"
    ERR_DISK_SATA4_FAIL = "21080042"
    ERR_DISK_SATA4_REMOVE = "21080043"
    ERR_DISK_SATA4_REMOVE_RAID_FAIL = "21080044"
    ERR_DISK_SATA4_REMOVE_RAID_DEGRADE = "21080045"
    ERR_DISK_SATA4_REMOVE_RAID_CRASH = "21080046"
    ERR_DISK_SATA5_DETECT_ERROR = "21080050"
    ERR_DISK_SATA5_CAP_SHORTAGE = "21080051"
    ERR_DISK_SATA5_FAIL = "21080052"
    ERR_DISK_SATA5_REMOVE = "21080053"
    ERR_DISK_SATA5_REMOVE_RAID_FAIL = "21080054"
    ERR_DISK_SATA5_REMOVE_RAID_DEGRADE = "21080055"
    ERR_DISK_SATA5_REMOVE_RAID_CRASH = "21080056"
    ERR_DISK_SATA6_DETECT_ERROR = "21080060"
    ERR_DISK_SATA6_CAP_SHORTAGE = "21080061"
    ERR_DISK_SATA6_FAIL = "21080062"
    ERR_DISK_SATA6_REMOVE = "21080063"
    ERR_DISK_SATA6_REMOVE_RAID_FAIL = "21080064"
    ERR_DISK_SATA6_REMOVE_RAID_DEGRADE = "21080065"
    ERR_DISK_SATA6_REMOVE_RAID_CRASH = "21080066"
    ERR_DISK_USB2_DETECT_ERROR = "21080120"
    ERR_DISK_USB2_FAIL = "21080126"
    ERR_DISK_USB3_DETECT_ERROR = "21080130"
    ERR_DISK_USB3_REMOVE = "21080131"
    ERR_DISK_USB3_REMOVE_RAID_FAIL = "21080132"
    ERR_DISK_USB3_REMOVE_RAID_DEGRADE = "21080133"
    ERR_DISK_USB3_REMOVE_RAID_CRASH = "21080134"
    ERR_DISK_USB3_CAP_SHORTAGE = "21080135"
    ERR_DISK_USB3_FAIL = "21080136"
    ERR_DISK_USB4_DETECT_ERROR = "21080140"
    ERR_DISK_USB4_REMOVE = "21080141"
    ERR_DISK_USB4_REMOVE_RAID_FAIL = "21080142"
    ERR_DISK_USB4_REMOVE_RAID_DEGRADE = "21080143"
    ERR_DISK_USB4_REMOVE_RAID_CRASH = "21080144"
    ERR_DISK_USB4_CAP_SHORTAGE = "21080145"
    ERR_DISK_USB4_FAIL = "21080146"
    MSG_ACTIVE_REPAIR_CHANGE = "22000000"
    MSG_ACTIVE_REPAIR_START = "22000001"
    MSG_ACTIVE_REPAIR_STOP = "22000002"
    MSG_ACTIVE_REPAIR_COMPLETE = "22000003"
    MSG_ACTIVE_REPAIR_ERR_COMPLETE = "22000004"
    MSG_ACTIVE_REPAIR_INTERNAL_START = "22000010"
    MSG_ACTIVE_REPAIR_INTERNAL_PROGRESS = "22000011"
    MSG_ACTIVE_REPAIR_INTERNAL_END = "22000012"
    MSG_ACTIVE_REPAIR_MIRROR_START = "22000020"
    MSG_ACTIVE_REPAIR_MIRROR_PROGRESS = "22000021"
    MSG_ACTIVE_REPAIR_MIRROR_END = "22000022"
    ERR_ACTIVE_REPAIR_STATE_CHANGE = "22030000"
    ERR_ACTIVE_REPAIR_BG_STATE_CHANGE = "22030001"
    ERR_ACTIVE_REPAIR_CHANGE = "22040000"
    ERR_ACTIVE_REPAIR_START = "22040001"
    ERR_ACTIVE_REPAIR_STOP = "22040002"
    ERR_ACTIVE_REPAIR_PROCESS = "22040003"
    ERR_ACTIVE_REPAIR_INTERNAL_REPAIR = "22080010"
    ERR_ACTIVE_REPAIR_MIRROR_REPAIR = "22080020"
    ERR_ACTIVE_REPAIR_SYSTEM_REPAIR = "22080030"
    MSG_LOCKKEY_CHANGE = "23000000"
    MSG_LOCKKEY_DELETE = "23000001"
    MSG_LOCKKEY_COPY = "23000002"
    MSG_LOCKKEY_SECURITY_UNLOCK = "23000003"
    MSG_LOCKKEY_TRANSFORM = "23000004"
    MSG_LOCKKEY_REGISTER = "23000005"
    MSG_LOCKKEY_DOWNLOAD = "23000006"
    MSG_LOCKKEY_USB1_SECURITY_UNLOCK = "23000110"
    MSG_LOCKKEY_USB2_SECURITY_UNLOCK = "23000120"
    MSG_LOCKKEY_USB3_SECURITY_UNLOCK = "23000130"
    MSG_LOCKKEY_USB4_SECURITY_UNLOCK = "23000140"
    ERR_LOCKKEY_STATE_CHANGE = "23030000"
    ERR_LOCKKEY_CHANGE = "23040000"
    ERR_LOCKKEY_DELETE = "23040001"
    ERR_LOCKKEY_COPY = "23040002"
    ERR_LOCKKEY_SECURITY_UNLOCK = "23040003"
    ERR_LOCKKEY_TRANSFORM = "23040004"
    ERR_LOCKKEY_REGISTER = "23040005"
    ERR_LOCKKEY_DOWNLOAD = "23040006"
    ERR_LOCKKEY_USB1_SECURITY_UNLOCK = "23040110"
    ERR_LOCKKEY_USB2_SECURITY_UNLOCK = "23040120"
    ERR_LOCKKEY_USB3_SECURITY_UNLOCK = "23040130"
    ERR_LOCKKEY_USB4_SECURITY_UNLOCK = "23040140"
    ERR_LOCKKEY_KEY_SERVER_AUTH = "23050000"
    ERR_LOCKKEY_NO_KEY_FILE = "23060000"
    ERR_LOCKKEY_DISK_NOT_FOUND = "23080000"
    ERR_LOCKKEY_DISK_CAP_SHORTAGE = "23080001"
    ERR_LOCKKEY_DISK_OTHER_LANDISK = "23080002"
    ERR_LOCKKEY_LOCKKEY_NOT_FOUND = "23080003"
    ERR_LOCKKEY_KEY_SERVER_CONNECT = "23090000"
    ERR_LOCKKEY_SECURITY_LOCK_MODE = "23100000"
    ERR_LOCKKEY_OLD_KEY_SERVER = "23100001"
    ERR_LOCKKEY_USB1_SECURITY_LOCK_MODE = "23100110"
    ERR_LOCKKEY_USB2_SECURITY_LOCK_MODE = "23100120"
    ERR_LOCKKEY_USB3_SECURITY_LOCK_MODE = "23100130"
    ERR_LOCKKEY_USB4_SECURITY_LOCK_MODE = "23100140"
    MSG_UPS_CHANGE = "24000000"
    MSG_UPS_DETECT_UPS = "24000001"
    MSG_UPS_DETECT_POWER_RECOVER = "24000002"
    MSG_UPS_DETECT_POWER_RECOVER_NOWARN = "24000003"
    MSG_UPS_SEND_NETSHUTDOWN_REQUEST = "24000004"
    MSG_UPS_SERIAL1_PLUG = "24000010"
    MSG_UPS_USB1_PLUG = "24000110"
    MSG_UPS_USB1_UNPLUG = "24000111"
    MSG_UPS_USB2_PLUG = "24000120"
    MSG_UPS_USB2_UNPLUG = "24000121"
    MSG_UPS_USB3_PLUG = "24000130"
    MSG_UPS_USB3_UNPLUG = "24000131"
    MSG_UPS_USB4_PLUG = "24000140"
    MSG_UPS_USB4_UNPLUG = "24000141"
    ERR_UPS_STATE_CHANGE = "24030000"
    ERR_UPS_CHANGE = "24040000"
    ERR_UPS_GET_STATUS = "24040001"
    ERR_UPS_SEND_NETSHUTDOWN_REQUEST = "24040002"
    ERR_UPS_DETECT_NO_UPS = "24080000"
    ERR_UPS_DETECT_NOPOWER = "24100000"
    ERR_UPS_DETECT_NOPOWER_NOWARN = "24100001"
    ERR_UPS_DETECT_TIMEOUT = "24100002"
    ERR_UPS_DETECT_TIMEOUT_NOWARN = "24100003"
    ERR_UPS_DETECT_LOW_BATTERY = "24100004"
    ERR_UPS_DETECT_LOW_BATTERY_NOWARN = "24100005"
    MSG_PRINTER_BUFFER_CLEAR = "25000000"
    MSG_PRINTER_USB1_PLUG = "25000110"
    MSG_PRINTER_USB1_UNPLUG = "25000111"
    MSG_PRINTER_USB2_PLUG = "25000120"
    MSG_PRINTER_USB2_UNPLUG = "25000121"
    MSG_PRINTER_USB3_PLUG = "25000130"
    MSG_PRINTER_USB3_UNPLUG = "25000131"
    MSG_PRINTER_USB4_PLUG = "25000140"
    MSG_PRINTER_USB4_UNPLUG = "25000141"
    ERR_PRINTER_STATE_CHANGE = "25030000"
    ERR_PRINTER_BUFFER_CLEAR = "25040000"
    MSG_SERVICE_CHANGE = "26000000"
    ERR_SERVICE_STATE_CHANGE = "26030000"
    ERR_SERVICE_CHANGE = "26040000"
    MSG_MAIL_CHANGE = "27000000"
    MSG_MAIL_TEST_SEND = "27000010"
    MSG_MAIL_SEND_REPORT = "27000011"
    MSG_MAIL_SEND_SYSTEM_EVENT = "27000012"
    MSG_MAIL_SEND_BACKUP = "27000013"
    MSG_MAIL_SEND_TEMP_FAN = "27000014"
    MSG_MAIL_SEND_DISKERROR = "27000015"
    MSG_MAIL_SEND_CAPACITY = "27000016"
    MSG_MAIL_SEND_QUOTA = "27000017"
    MSG_MAIL_SEND_UPS = "27000018"
    MSG_MAIL_SEND_SYSTEM_LOG = "27000019"
    MSG_MAIL_SEND_ACCESS_LOG = "27000020"
    MSG_MAIL_SEND_RETRY = "27000030"
    ERR_MAIL_STATE_CHANGE = "27030000"
    ERR_MAIL_CHANGE = "27040000"
    ERR_MAIL_TEST_SEND = "27090000"
    ERR_MAIL_SEND_REPORT = "27090001"
    ERR_MAIL_SEND_SYSTEM_EVENT = "27090002"
    ERR_MAIL_SEND_BACKUP = "27090003"
    ERR_MAIL_SEND_TEMP_FAN = "27090004"
    ERR_MAIL_SEND_DISKERROR = "27090005"
    ERR_MAIL_SEND_CAPACITY = "27090006"
    ERR_MAIL_SEND_QUOTA = "27090007"
    ERR_MAIL_SEND_UPS = "27090008"
    ERR_MAIL_SEND_SYSTEM_LOG = "27090009"
    ERR_MAIL_SEND_ACCESS_LOG = "27090010"
    ERR_MAIL_SEND_RETRY = "27090020"
    MSG_REPORT_CHANGE = "28000000"
    ERR_REPORT_STATE_CHANGE = "28030000"
    ERR_REPORT_CHANGE = "28040000"
    MSG_PERIODIC_CHANGE = "29000000"
    ERR_PERIODIC_STATE_CHANGE = "29030000"
    ERR_PERIODIC_CHANGE = "29040000"
    MSG_SNMP_CHANGE = "30000000"
    MSG_SNMP_TRAP_SEND = "30000001"
    ERR_SNMP_STATE_CHANGE = "30030000"
    ERR_SNMP_CHANGE = "30040000"
    ERR_SNMP_TRAP_SEND = "30090000"
    MSG_NARSUS_CHANGE = "31000000"
    MSG_NARSUS_INTERVAL_NOTIFY = "31000001"
    ERR_NARSUS_STATE_CHANGE = "31030000"
    ERR_NARSUS_CHANGE = "31040000"
    ERR_NARSUS_USECODE = "31050000"
    ERR_NARSUS_CONNECT = "31090000"
    MSG_POWER_CHANGE = "32000000"
    MSG_POWER_SHUTDOWN = "32000001"
    MSG_POWER_REBOOT = "32000002"
    ERR_POWER_STATE_CHANGE = "32030000"
    ERR_POWER_CHANGE = "32040000"
    MSG_SWITCH_CHANGE = "33000000"
    ERR_SWITCH_STATE_CHANGE = "33030000"
    ERR_SWITCH_CHANGE = "33040000"
    MSG_LAMP_CHANGE = "34000000"
    ERR_LAMP_STATE_CHANGE = "34030000"
    ERR_LAMP_CHANGE = "34040000"
    MSG_ECO_CHANGE = "35000000"
    ERR_ECO_STATE_CHANGE = "35030000"
    ERR_ECO_CHANGE = "35040000"
    MSG_PKG_CHANGE = "36000000"
    MSG_PKG_INSTALL = "36000001"
    MSG_PKG_UPDATE = "36000002"
    MSG_PKG_UNINSTALL = "36000003"
    MSG_PKG_LATEST_PACKAGE = "36000004"
    MSG_PKG_NEW_PACKAGE_FOR_NEW_FIRM = "36000005"
    MSG_PKG_AUTO_UPDATE = "36000010"
    ERR_PKG_STATE_CHANGE = "36030000"
    ERR_PKG_CHANGE = "36040000"
    ERR_PKG_INSTALL = "36040001"
    ERR_PKG_UPDATE = "36040002"
    ERR_PKG_UNINSTALL = "36040003"
    ERR_PKG_AUTO_UPDATE = "36040010"
    ERR_PKG_CONNECT = "36090000"
    ERR_PKG_NEW_PACKAGE = "36110000"
    MSG_FIRMWARE_CHANGE = "37000000"
    MSG_FIRMWARE_UPDATE_START = "37000001"
    MSG_FIRMWARE_LATEST_FIRMWARE = "37000002"
    MSG_FIRMWARE_SUCCESS_FIRMWARE = "37000003"
    MSG_FIRMWARE_AUTO_UPDATE_START = "37000010"
    ERR_FIRMWARE_STATE_CHANGE = "37030000"
    ERR_FIRMWARE_CHANGE = "37040000"
    ERR_FIRMWARE_FAIL_FIRMWARE = "37040001"
    ERR_FIRMWARE_AUTO_UPDATE_START = "37040010"
    ERR_FIRMWARE_INVALID_FIRMWARE = "37060000"
    ERR_FIRMWARE_CONNECT = "37090000"
    ERR_FIRMWARE_NEW_FIRMWARE = "37110000"
    MSG_LOG_FILTER_CHANGE = "38000000"
    ERR_LOG_STATE_CHANGE = "38030000"
    ERR_LOG_FILTER_CHANGE = "38040000"
    MSG_ANNOUNCE_CLEAR = "39000000"
    ERR_ANNOUNCE_STATE_CHANGE = "39030000"
    ERR_ANNOUNCE_CLEAR = "39040000"
    MSG_PROXY_CHANGE = "40000000"
    ERR_PROXY_STATE_CHANGE = "40030000"
    ERR_PROXY_CHANGE = "40040000"
    MSG_SYSTEM_BOOT_DONE = "41000000"
    MSG_SYSTEM_SHUTDOWN = "41000001"
    MSG_SYSTEM_REBOOT = "41000002"
    MSG_SYSTEM_WEB_LOGIN = "41000010"
    MSG_SYSTEM_WEB_LOGOUT = "41000011"
    ERR_SYSTEM_STATE_CHANGE = "41030000"
    ERR_SYSTEM_WEB_LOGIN = "41050000"
    ERR_SYSTEM_WEB_MULTI_LOGIN = "41050001"
    ERR_SYSTEM_SHUTDOWN_CANCEL = "41110000"
    ERR_TEMP_FAN_TEMPERATURE = "42100000"
    ERR_TEMP_FAN_FAN_STOP = "42100001"
    MSG_SYS_INIT_START = "43000000"
    MSG_SYS_INIT_COMPLETE = "43000001"
    ERR_SYS_INIT_STATE_CHANGE = "43030000"
    ERR_SYS_INIT_FAIL = "43040000"
    MSG_TOOLS_GET_INFO_START = "44000000"
    MSG_TOOLS_GET_INFO_COMPLETE = "44000001"
    MSG_TOOLS_SET_INFO_START = "44000010"
    MSG_TOOLS_SET_INFO_COMPLETE = "44000011"
    MSG_TOOLS_RECEIVE_NETSHUTDOWN_REQUEST = "44000020"
    ERR_TOOLS_STATE_CHANGE = "44030000"
    ERR_TOOLS_GET_INFO = "44040000"
    ERR_TOOLS_SET_INFO = "44040001"
    ERR_TOOLS_SET_INFO_NEW_FAIL = "44040002"
    ERR_LCM_RAID_DEGRADE = "50100000"
    ERR_LCM_RAID_CRASH = "50100001"
    ERR_LCM_RAID_FAIL = "50100002"
    ERR_LCM_SECURITY_LOCK = "50100003"
    MSG_LCM_NOTICE_STR = "50100004"
    MSG_LCM_NOTICE_EXIST = "50100005"
    MSG_LCM_NO_NOTICE = "50100006"
    MSG_LCM_ECO_STATE = "50100007"
    MSG_LCM_INTERNAL_VOL = "50100008"
    MSG_LCM_MIRRORING_VOL = "50100009"
    MSG_LCM_REBUILDING = "50100010"
    MSG_LCM_FREE_SPACE = "50100011"
    MSG_LCM_NO_LINK = "50100015"
    ERR_LCM_MODEL_UNKNOWN = "50100016"
    ERR_LCM_HOST_UNKNOWN = "50100017"
    ERR_LCM_MAC_UNKNOWN = "50100018"
    MSG_LCM_RAID_STR = "50100019"
    MSG_LCM_VOL_STR = "50100020"
    MSG_LCM_UNKNOWN_STR = "50100021"
    MSG_LCM_SYSTEM_STR = "50100022"
    MSG_LCM_UPDATING_STR = "50100023"


XML_LANG_ATTR_NAME = "{http://www.w3.org/XML/1998/namespace}lang"


_PRODUCT_CATEGORY_LIST = []
for category in _CATEGORY_LIST:
    if category in IGNORE_CATEGORY_LIST:
        continue
    _PRODUCT_CATEGORY_LIST.append(category)


def get_lang():
    """Return the preferable string for "lang"."""

    locale_lang = locale.getdefaultlocale()[0]
    if locale_lang in _LOCALE_MAP:
        return _LOCALE_MAP[locale_lang]
    return _LOCALE_MAP["ja_JP"]


def get_category_list():
    """Return the list of category code."""

    return _PRODUCT_CATEGORY_LIST


def get_category_str(cat_code):
    """Return the string for the category code."""

    try:
        str_list = _CATEGORY_STR_LIST_DICT[get_lang()]
    except:
        str_list = _CATEGORY_STR_LIST_DICT[""]

    try:
        return str_list[cat_code]
    except:
        return str_list[Cat.UNKNOWN]


def get_category_code(msg_code):
    """Return the category code for the "msg_code"."""

    try:
        if not isinstance(msg_code, int):
            msg_code = int(msg_code)
        return str((msg_code / _MESSAGE_CODE_UNIT / _CATEGORY_CODE_UNIT) *
                    _CATEGORY_CODE_UNIT)
    except:
        return Cat.UNKNOWN


def get_query_entry(code, arg_dict={}, for_lcm=False):
    """Return "ionas.request.Entry" instance for "query" request about
       "code" and "arg_list".
    """

    entry = request.Entry(ReqTypes.QUERY,
                    fal_info.FAL_MESSAGES_REQ_BASE_XML[ReqTypes.QUERY])
    entry.get().get_node(_CODE_PATH).set_text(code)
    if for_lcm:
        entry.get().append_child("option", text=None, attrs={"for_lcm": "true"})
    if len(arg_dict):
        arglist = xmldata.XmlConfNode(_ARGLIST_NAME)
        for name in arg_dict:
            arglist.append_child(_ARG_NAME, arg_dict[name],
                                    {_NAME_NAME: name})
        entry.get().get_node(_MESSAGEINFO_PATH).append_child(arglist)
    return entry
