# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

"""FAL commands information module.

Note : DO NOT EDIT.  This is automatically generated.
"""

import locale


_LOCALE_MAP = {"": "", "ja_JP": "ja"}


def _get_lang():
    """Return the preferable string for "lang"."""

    locale_lang = locale.getdefaultlocale()[0]
    if locale_lang in _LOCALE_MAP:
        return _LOCALE_MAP[locale_lang]
    return _LOCALE_MAP["ja_JP"]


_CURRENT_LANG = _get_lang()



class LanDiskName:
    VALIDATOR = 'LanDiskName'
    MAX_LENGTH = 15
    MIN_LENGTH = 1

class AdUserName:
    VALIDATOR = 'AdUserName'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class Comment:
    VALIDATOR = 'Comment'
    MAX_COUNT = 48
    MIN_COUNT = 1

class DomainName:
    VALIDATOR = 'DomainName'
    MAX_LENGTH = 155
    MIN_LENGTH = 1

class ShareComment:
    VALIDATOR = 'ShareComment'
    MAX_LENGTH = 15
    MIN_LENGTH = 1

class ShareName:
    VALIDATOR = 'ShareName'
    MAX_LENGTH = 27
    MIN_LENGTH = 1

class ShareNameEdit:
    VALIDATOR = 'ShareNameEdit'
    MAX_LENGTH = 27
    MIN_LENGTH = 1

class Fqdn:
    VALIDATOR = 'Fqdn'
    MAX_LENGTH = 128
    MIN_LENGTH = 1

class GroupName:
    VALIDATOR = 'GroupName'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class IpAddress:
    VALIDATOR = 'IpAddress'

class IssCode:
    VALIDATOR = 'IssCode'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class LanDiskPass:
    VALIDATOR = 'LanDiskPass'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class MailUserName:
    VALIDATOR = 'MailUserName'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class MailAddress:
    VALIDATOR = 'MailAddress'
    MAX_LENGTH = 50
    MIN_LENGTH = 1

class NoCheck:
    VALIDATOR = 'NoCheck'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class LocalPortNumber:
    VALIDATOR = 'LocalPortNumber'
    MAX = 65535
    MIN = 1

class RemotePortNumber:
    VALIDATOR = 'RemotePortNumber'
    MAX = 65535
    MIN = 1

class Quota:
    VALIDATOR = 'Quota'
    MAX_LENGTH = 7
    MIN_LENGTH = 1
    MAX = 99999.9
    MIN = 0

class SerialNumber:
    VALIDATOR = 'SerialNumber'

class DateTime:
    VALIDATOR = 'DateTime'

class Url:
    VALIDATOR = 'Url'
    MAX_LENGTH = 128
    MIN_LENGTH = 7

class UserName:
    VALIDATOR = 'UserName'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class UserNameEdit:
    VALIDATOR = 'UserNameEdit'
    MAX_LENGTH = 20
    MIN_LENGTH = 1

class WorkGroup:
    VALIDATOR = 'WorkGroup'
    MAX_LENGTH = 15
    MIN_LENGTH = 1

class NetBIOSDomainName:
    VALIDATOR = 'NetBIOSDomainName'
    MAX_LENGTH = 15
    MIN_LENGTH = 1

class Numeric:
    VALIDATOR = 'Numeric'
    MAX = 65535
    MIN = 1

class UserInItem:
    VALIDATOR = 'UserInItem'

class GroupInItem:
    VALIDATOR = 'GroupInItem'

class ShareInItem:
    VALIDATOR = 'ShareInItem'

class Boolean:
    VALIDATOR = 'Boolean'

class Year:
    VALIDATOR = 'Year'

class Month:
    VALIDATOR = 'Month'

class Day:
    VALIDATOR = 'Day'

class Hour:
    VALIDATOR = 'Hour'

class Minute:
    VALIDATOR = 'Minute'

class Second:
    VALIDATOR = 'Second'

class MinuteInterval5:
    VALIDATOR = 'MinuteInterval5'

class MinuteInterval10:
    VALIDATOR = 'MinuteInterval10'

class String:
    VALIDATOR = 'String'
    MAX_COUNT = 256
    MIN_COUNT = 1

class BackupJobName:
    VALIDATOR = 'BackupJobName'
    MAX_COUNT = 48
    MIN_COUNT = 1

class DataCopyJobName:
    VALIDATOR = 'DataCopyJobName'
    MAX_COUNT = 48
    MIN_COUNT = 1

class UncShare:
    VALIDATOR = 'UncShare'
    MAX_COUNT = 256
    MIN_COUNT = 1

