var MoveBox = function(select, subselect, move, remove, submit) {
	// select & subselect はセレクトフィールド(multi)
	// 両者間で要素が移動し、select にある要素をユーザー入力と見做す。
	// 両者は(順番も含めて)同一の options を持つこと
	// move で示される要素をの onclick で subselect -> select
	// remove で示される要素をの onclick で select -> subselect
	// submit ではサブミットボタンを指定すること
	function _(elem_or_id) {
		return typeof elem_or_id == 'object' ? elem_or_id : document.getElementById(elem_or_id);
	}
	this.select = _(select);
	this.subselect = _(subselect);
	var move = _(move);
	var remove = _(remove);
	var submit = _(submit);

	var that = this;

	for (var i=this.select.length-1; i>-1; i--) {
		this.select.options[i].selected ? this.subselect.remove(i) : this.select.remove(i);
	}

	move.onclick = function(e){that.move();};
	remove.onclick = function(e){that.remove();};
	submit.onclick = function(e){that.beforeSubmit();};
}
MoveBox.prototype = {
	_move: function(from, to) {
		// FIXME 移動項目のソートをつけるか否か パフォーマンスも気になる
		if (from.selectedIndex == -1) {return;}
		while (from.selectedIndex >= 0) {
			var option = new Option();
			option.text = from.options[from.selectedIndex].text;
			option.value = from.options[from.selectedIndex].value;
			try { option.title = from.options[from.selectedIndex].title; } catch (e) {}
			to.options[to.options.length] = option;
			from.remove(from.selectedIndex);
		}
	},
	move: function() {
		this._move(this.subselect, this.select);
	},
	remove: function() {
		this._move(this.select, this.subselect);
	},
	beforeSubmit: function() {
		for (var i=0; i<this.select.options.length; i++) {
			this.select.options[i].selected = true;
		}
	}
}
