function addEvent(obj, type, func) {
        try { obj.addEventListener(type, func, false); }
        catch (e) { obj.attachEvent('on'+type, func); }
}

// スリープ
function sleep(sec) {
	var d1 = new Date().getTime();
	var d2 = new Date().getTime();
	while (d2<d1+1000*sec) {
		d2=new Date().getTime();
	}
	return;
}

// Array のメソッドとして inArray(val) が使えるようにする
// inArray(val) は配列要素中の val の 有/無 で true/false を返す
Array.prototype.inArray = function(val) {
	for (var i=0, l=this.length; i<l; i++) {
		if (this[i] == val) { return true; }
	}
	return false;
}

// 子のノードの内でtagsのタグのノードのみを取得する
function getChildNodes(parent_, tags) {
	var childNodes = Array();
	var elem = (typeof parent_ == 'object') ? parent_ : document.getElementById(parent_);
	if (! elem) { return childNodes; }
	if (! tags) { return elem.childNodes; }
	for (var i=0; i<elem.childNodes.length; i++) {
		if (tags.inArray(elem.childNodes[i].nodeName.toLowerCase())) {
			childNodes[childNodes.length] = elem.childNodes[i];
		}
	}
	return childNodes;
}

// formデータをhashに変換する(ajax の data として扱える形式にする
function formToHash(form) {
//	var fe = typeof form == 'object' ? form : document.getElementById(form);
//	if (! fe) { return false; }
	var data = {};
	$('#' + form).find('input, select, textarea').each(function(){
		var elem = $(this);
		var name = elem.attr('name');
		var value = elem.val();
		if (typeof name === 'undefined' ||
		    elem.attr('disabled') ||
		    this.tagName.toLowerCase() === 'input' && elem.attr('type') === 'checkbox' && !elem.attr('checked')) {
			return false;
		}
		if (name in data) {
			if (data[name] instanceof Array) {
				data[name].push(value);
			} else {
				data[name] = [data[name], value];
			}
		} else {
			data[name] = value;
		}
	});
	return data;
}

var ChgDisp = function(radioName, options) {
	var that = this;

	if (! options) { options = {}; }
	this.options = {
		before: options.before ? options.before : function(){},
		after: options.after ? options.after : function(){}
	}

	this.dispItems = {};
	var choices = document.getElementsByName(radioName);
	for (var i=0; i<choices.length; i++) {
		choices[i].onclick = function(e){that.change(this.value)};
		this.dispItems[choices[i].value] = document.getElementById(radioName + '_' + choices[i].value);
		if (! this.dispItems[choices[i].value]) { continue; }
		if (! choices[i].checked) {
			this.dispItems[choices[i].value].style.display = 'none';
		}
	}
}
ChgDisp.prototype = {
	change: function(choice) {
		this.options.before();
		for (var key in this.dispItems) {
			if (key == choice) {
				this.dispItems[key].style.display = '';
			} else {
				this.dispItems[key].style.display = 'none';
			}
		}
		this.options.after();
	}
}
