# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
try:
    from django.conf import settings
    TEMP = settings.TMP
except ImportError:
    TEMP = '/var/tmp/www/'
from fal.user import User
import os
import time


class Authentication(object):
    LOGINFILE_DIR = TEMP
    LOGINFILE_PATH = os.path.join(LOGINFILE_DIR, 'login.txt')
    EX_MODE = False

    def check_password(self, password):
        user = User()
        user.auth(user='admin', password=password)
        if int(user.get_result()):
            return False
        return True

    def login(self, request, password):
        try:
            if self.is_logined_other(request) and self.EX_MODE is False:
                # 他人がログインしてたら不可
                return False
            if not self.check_password(password):
                # パスワード違うなら不可
                return False
            if self.update(request):
                request.session.cycle_key()  # sessionid再生成
                return True
            else:
                return False
        except:
            self.logout(request)
            return False

    def logout(self, request):
        if not self.is_logined(request):
            return False
        try:
            os.remove(self.LOGINFILE_PATH)
            request.session.flush()
            return True
        except IOError:
            return False

    def update(self, request):
        try:
            f = open(self.LOGINFILE_PATH, 'w')
            f.write(request.META['REMOTE_ADDR'])
            f.close()
        except IOError:
            return False
        return True

    def is_logined(self, request, reset_logout_count=True):
        if not os.path.exists(self.LOGINFILE_PATH):
            return False
        ftime = os.path.getmtime(self.LOGINFILE_PATH)
        ntime = time.time()
        if int(ftime) + self.__get_timeout() < int(ntime):  # Timeout
            return False
        try:
            f = open(self.LOGINFILE_PATH, 'r')
            ipaddr = f.read()
            f.close()
            if not ipaddr:
                f = open(self.LOGINFILE_PATH, 'r')
                ipaddr = f.read()
                f.close()
            if not ipaddr:
                f = open(self.LOGINFILE_PATH, 'r')
                ipaddr = f.read()
                f.close()
        except IOError:
            return False
        if request.META['REMOTE_ADDR'] == ipaddr or self.EX_MODE is True:
            if reset_logout_count:
                self.update(request)
            return True
        return False

    def is_logined_other(self, request):
        if not os.path.exists(self.LOGINFILE_PATH):
            return False
        ftime = os.path.getmtime(self.LOGINFILE_PATH)
        ntime = time.time()
        if int(ftime) + self.__get_timeout() < int(ntime):  # Timeout
            return False
        try:
            f = open(self.LOGINFILE_PATH, 'r')
            ipaddr = f.read()
            f.close()
        except IOError:
            return False
        if ipaddr and request.META['REMOTE_ADDR'] != ipaddr:
            return True
        return False

    def __get_timeout(self):
        timeout = 10  # min
        try:
            timeout = int(User().load(all=True)['admin']['timeout'])
        except:
            timeout = 10
        return timeout * 60  # sec
