# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from command import Command, _
from ionas.request import Entry


class Buzzer(Command):
    try:
        from fal_info import FAL_BUZZER_PATH as COMMAND
    except:
        COMMAND_NAME = 'fal_buzzer.py'

    TYPE_PLAY = 'play'
    TYPE_STOP = 'stop'

    def play(self, mtype='stop'):
        entry = self.request(Entry(
                self.TYPE_PLAY,
                '<buzzer><melody type="%s" /></buzzer>' % mtype))
        return entry

    def stop(self):
        entry = self.request(Entry(self.TYPE_STOP, '<buzzer />'))
        return entry

    def melody(self):
        return self.play(mtype="melody")

    def ok(self):
        return self.play(mtype="ok")

    def error(self):
        return self.play(mtype="error")


if __name__ == '__main__':
    import time
    buz = Buzzer()

    buz.melody()
    time.sleep(3)
    buz.stop()

    buz.ok()
    time.sleep(3)

    buz.error()
    time.sleep(3)

    buz.stop()
