# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from command import Command, _, escape
from ionas.request import Entry, XmlNode
from product_conf import STOR_IF_TO_VOL
from product_conf.devinfo import SATA_HDD_DEV_LIST
from product_conf.devinfo import USB_HDD_DEV_LIST, USB_UPS_DEV_LIST
from fal_info import Results


class Devctrl(Command):
    try:
        from fal_info import FAL_DEVCTRL_PATH as COMMAND
    except:
        COMMAND_NAME = 'fal_devctrl.py'

    TYPE_LIST = 'list'

    DEV_LIST = SATA_HDD_DEV_LIST + USB_HDD_DEV_LIST + USB_UPS_DEV_LIST
    DEV = {
        'sata': {
            'hdd': [''] + list(SATA_HDD_DEV_LIST),
        },
        'usb': {
            'hdd': [''] + list(USB_HDD_DEV_LIST),
            'ups': [''] + list(USB_UPS_DEV_LIST),
        }
    }

    def list(self, to_dict=True):
        def _to_dict(entry):
            dict_ = {}
            try:
                for dev_node in entry.get().get_node_list('devicelist/device'):
                    name = dev_node.get_value('name', None)
                    if name is None:
                        continue
                    dict_[name] = {}
                    dict_[name]['name'] = name
                    dict_[name]['disk'] = {}
                    dict_[name]['disk']['vendor'] = \
                            dev_node.get_value('disk/vendor', None)
                    dict_[name]['disk']['model'] = \
                            dev_node.get_value('disk/model', None)
                    dict_[name]['disk']['rev'] = \
                            dev_node.get_value('disk/rev', None)
                    dict_[name]['disk']['size'] = \
                            dev_node.get_value('disk/size', None)
            except:
                pass
            return dict_
        entry = self.request(Entry(self.TYPE_LIST, """<devctrl />"""))
        return _to_dict(entry) if to_dict else entry

#    def is_connected(self, dev='usb', type='hdd', port=1):
    def is_connected(self, device=DEV['usb']['hdd'][1]):
        try:
            if self.list().get(device, None):
                return True
            else:
                return False
        except:
            return False

if __name__ == '__main__':
    i = Devctrl()

    print i.list()

 #   print "CONNECTED(usbd1): %s" % i.is_connected(device=i.DEV["usb"]["hdd"][1])
 #   print "CONNECTED(usbd1): %s" % i.is_connected(device=i.DEV["usb"]["ups"][1])
