# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from subprocess import call, Popen, PIPE
import time

from product_conf import EEDATA_CMD, SUDO_CMD


def _eedata(*args):
    cmd = [SUDO_CMD, EEDATA_CMD] + list(args)
    process = Popen(cmd, stdout=PIPE)
    process.wait()
    if process.returncode != 0:
        return 0
    return process.stdout.read()


def _eedata_read(target):
    return int(_eedata("--read", "--%s" % target), 16)


def _eedata_write(target, value):
    _eedata("--write", "--%s" % target, value)


class EEPROM(object):

    def uptime(self):
        return _eedata_read("uptime")

    def fantime(self):
        return _eedata_read("fantime")

    def powertime(self):
        return _eedata_read("powertime")

    def powercycle(self):
        return _eedata_read("powercycle")

    def fanfail(self):
        return _eedata_read("fanfail")

    def tempfail(self):
        return _eedata_read("tempfail")

    def gplv3(self, data=None):
        if int(bool(data)):
            _eedata_write("nowarranty", "1")
        return _eedata_read("nowarranty")

if __name__ == '__main__':
    eeprom = EEPROM()
    print "UPTIME: %s" % eeprom.uptime()
    print "FANTIME: %s" % eeprom.fantime()
    print "POWERTIME: %s" % eeprom.powertime()
    print "POWERCYCLE: %s" % eeprom.powercycle()
    print "FANFAILE: %s" % eeprom.fanfail()
    print "TEMPFAIL: %s" % eeprom.tempfail()
    print "GPLV3: %s" % eeprom.gplv3()
