# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from command import Command
from ionas.request import Entry
from fal_info import Results


class QRCode(Command):
    try:
        from fal_info import FAL_QRCODE_PATH as COMMAND
    except:
        COMMAND_NAME = 'fal_qrcode.py'

    TYPE_ENCODE = 'encode'


    def encode(self, string=None, path=None, to_bool=True):
        entry = Entry(self.TYPE_ENCODE, """<qrcode>
            <data />
        </qrcode>""")
        entry.set_file(path)
        entry.get().get_node('data').set_text(string)
        entry = self.request(entry)
        result = entry.get_result()
        if int(result) == int(Results.OK):
            result = True
        else:
            result = True
        return result if to_bool else entry


if __name__ == '__main__':
    i = QRCode()

    print i.encode(string="abc", path="/tmp/qr.png", to_bool=False)
