# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from command import Command, _
from ionas.request import Entry, XmlNode


class SelfCheck(Command):
    try:
        from fal_info import FAL_SELFCHECK_PATH as COMMAND
    except:
        COMMAND_NAME = 'fal_selfcheck.py'

    TYPE_CHECK = 'selfcheck'
    TYPE_QUERY = 'query'
    TYPE_LOAD = 'load'

    def query(self):
        return self.request(Entry(
                self.TYPE_QUERY,
                '<selfcheck />'))  # Entry  #FIXME xml

    def check(self):
        pass

    def run(self, check):
        try:
            check = check if isinstance(check, XmlNode) else XmlNode(check)
        except:
            return None
        entry = Entry(self.TYPE_CHECK, '<selfcheck><checklist /></selfcheck>')
        entry.get().get_node('checklist').append_child(check)
        self.request(entry)
        if self.get_result() == 0:
            return True
        else:
            return False


if __name__ == '__main__':
    i = SelfCheck()
    print i.run('<check name="ping" enable="true">192.168.11.222</check>')

#    print "Run: %s" % i.get_message()
#    i.query().entry
#    print "Query: %s" % i.get_result()
#    print "Ping: %s" % (i.get_value('checklist/check[@name="ping"]/status'))
