# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms


class CheckboxField(forms.BooleanField):
#    widget = forms.widgets.CheckboxInput
    default_validators = []
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
    }

    def __init__(self,
            attrs=None,
            required=False,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(CheckboxField, self).__init__(
                required=required,
                widget=widget or self.widget(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)


class MultiCheckboxField(forms.MultipleChoiceField):
    widget = forms.CheckboxSelectMultiple
    default_validators = []
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
#        'invalid_list': _(u'Enter a list of values.'),
    }

    def __init__(self,
            required=False,
            *args, **kwargs):
        super(MultiCheckboxField, self).__init__(
                required=required,
                *args, **kwargs)
