# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms


class AdminPasswordField(forms.CharField):
    widget = forms.widgets.PasswordInput
    default_validators = []  #FIXME for landisk password format
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }

    def __init__(self,
            attrs=None,
            max_length=8,  #FIXME 8
            min_length=0,
            required=False,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(AdminPasswordField, self).__init__(
                max_length=max_length,
                min_length=min_length,
                required=required,
                widget=widget or self.widget(attrs=attrs, render_value=False),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)
