#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms


_empty_object = object()

class BackupHistoryNumberField(forms.IntegerField):

    def __init__(self,
                 label=_(u"FIELD_LABEL: BackupHistoryNumberField"),
                 max_value=31,
                 min_value=0,
                 initial=0,
                 help_text=_empty_object,
                 *args, **kwargs):
        if help_text is _empty_object:
            help_text = _(u"FIELD_HELP_TEXT: BackupHistoryNumberField %(max_value)s %(min_value)s") % {
                u"max_value": max_value,
                u"min_value": min_value,
            }
        super(BackupHistoryNumberField, self).__init__(label=label,
                                                       min_value=min_value,
                                                       max_value=max_value,
                                                       initial=initial,
                                                       help_text=help_text,
                                                       *args, **kwargs)
