# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from ..select import SelectField


class SelectBackupHistoryField(SelectField):
    #widget = forms.widgets.Select
    default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    }

    def _choice(self, val):
        import re
        m = re.match(r'(?P<year>[0-9]{4})(?P<month>[0-9]{2})(?P<day>[0-9]{2})(?P<hour>[0-9]{2})(?P<min>[0-9]{2})(?P<sec>[0-9]{2})', val)
        if m:
            return (
                val,
                u'%s/%s/%s %s:%s:%s' % (
                        m.group('year'),
                        m.group('month'),
                        m.group('day'),
                        m.group('hour'),
                        m.group('min'),
                        m.group('sec'),
                        )
            )
            pass
        else:
            return (
                val,
                val
            )

    def _datetimes(self, jobid):
        try:
            from project.fal.backups import Backups
            return reversed(sorted(
                    Backups().query()['backup'][jobid]['generationlist']))
        except:
            return []

    def __init__(self, jobid, *args, **kwargs):
        kwargs['choices'] = [('', _(u'Please select.'))] + \
                [self._choice(m) for m in self._datetimes(jobid)]
        super(SelectBackupHistoryField, self).__init__(*args, **kwargs)
