# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import BackupJobName, DataCopyJobName

class BackupJobNameValidator(FALValidator):
    validator = BackupJobName.VALIDATOR
    options = {}


class BackupJobNameField(TextField):
    default_error_messages = {}
    default_validators = []

    def __init__(self, max_length=BackupJobName.MAX_COUNT, *args, **kwargs):
        super(BackupJobNameField, self).__init__(
                max_length=max_length,
                *args, **kwargs)


class DatacopyJobNameValidator(FALValidator):
    validator = DataCopyJobName.VALIDATOR
    options = {}


class DatacopyJobNameField(TextField):
    default_error_messages = {}
    default_validators = []

    def __init__(self, max_length=DataCopyJobName.MAX_COUNT, *args, **kwargs):
        super(DatacopyJobNameField, self).__init__(
                max_length=max_length,
                *args, **kwargs)
