# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from ..password import PasswordField
from validators.fal import FALValidator
from fal_validinfo import String


MAX_COUNT = 127


class StringValidator(FALValidator):
    validator = String.VALIDATOR
    options = {"max_count": str(MAX_COUNT)}


class BackupPassField(PasswordField):
    default_error_messages = {}
    default_validators = [StringValidator()]

    def __init__(self, max_length=MAX_COUNT, *args, **kwargs):
        super(BackupPassField, self).__init__(
                max_length=max_length,
                *args, **kwargs)
