# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from django.core.exceptions import ValidationError
#from django.forms.extras.widgets import SelectDateWidget
from widgets.selectdate import SelectDateWidget
from widgets.selecttime import SelectTimeWidget
from widgets.selectdatetime import SelectDateTimeWidget


class SelectDateField(forms.DateField):
#    widget = forms.widgets.DateInput
    widget = SelectDateWidget
    default_error_messages = {
#        'invalid': _(u'Enter a valid date.'),
    }
#    default_validators = []


class SelectTimeField(forms.TimeField):
    widget = SelectTimeWidget
    default_error_messages = {
#        'invalid': _(u'Enter a valid date.'),
    }
#    default_validators = []

    def __init__(self,
            attrs=None,
            hour_step=None,
            minute_step=None,
            second_step=None,
            show_seconds=True,
            *args, **kwargs):
        super(SelectTimeField, self).__init__(
                widget=self.widget(
                        attrs=attrs,
                        hour_step=hour_step,
                        minute_step=minute_step,
                        second_step=second_step,
                        show_seconds=show_seconds),
                *args, **kwargs)


class SelectDateTimeField(forms.DateTimeField):
    widget = SelectDateTimeWidget
    default_error_messages = {
#        'invalid': _(u'Enter a valid date.'),
    }
#    default_validators = []
    def __init__(self, required=True, show_seconds=True, *args, **kwargs):
        super(SelectDateTimeField, self).__init__(
                widget=self.widget(
                        required=required,
                        show_seconds=show_seconds),
                required=required,
                *args, **kwargs)

    def clean(self, value):
        if isinstance(value, (list, tuple)):
            raise ValidationError(
                    self.error_messages['invalid'],
                    code='invalid')
        return super(SelectDateTimeField, self).clean(value)
