# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import MailAddress


class MailAddressValidator(FALValidator):
    validator = MailAddress.VALIDATOR
    options = {}


class EmailField(TextField):
#    widget = forms.widgets.TextInput
#    default_validators = [validators.validate_email]
    default_validators = [MailAddressValidator()]
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid e-mail address.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }

    def __init__(self,
            attrs=None,
            max_length=MailAddress.MAX_LENGTH,
            min_length=MailAddress.MIN_LENGTH,
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(EmailField, self).__init__(
                max_length=max_length,
                min_length=min_length,
                required=required,
                widget=widget or self.widget(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
#                validators=[MailAddressValidator()],
                *args, **kwargs)
