# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from ..checkbox import MultiCheckboxField


class LevelField(MultiCheckboxField):
    def __init__(self, initial=None, *args, **kwargs):
        super(LevelField, self).__init__(
                choices=(
                        (u'0', _(u'Info')),
                        (u'1', _(u'Warning')),
                        (u'2', _(u'Error')),
                ),
                initial=initial or (u'0', u'1', u'2'),
                *args, **kwargs)


class CategoryField(MultiCheckboxField):
    def __init__(self, initial=None, *args, **kwargs):
        choices = _initial = []
        try:
            from fal_msginfo import get_category_list, get_category_str
            _initial = get_category_list()
            choices = [(c, get_category_str(c)) for c in _initial]
        except:
            choices = _initial = []
        super(CategoryField, self).__init__(
                choices=choices,
                initial=initial or _initial,
                *args, **kwargs)
