# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from validators.fal import FALValidator
from fal_validinfo import NoCheck


class NoCheckValidator(FALValidator):
    validator = NoCheck.VALIDATOR
    options = {"max_length": "256"}


class FileField(forms.FileField):
    default_error_messages = {}
    default_validators = [NoCheckValidator()]

    def __init__(self, max_length=256, *args, **kwargs):
        super(FileField, self).__init__(
                max_length=max_length,
                *args, **kwargs)
