# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import Fqdn


class FQDNValidator(FALValidator):
    validator = Fqdn.VALIDATOR
    options = {}


class PingValidator(FQDNValidator):
    options = {"exempt_network_duplicate": "true"}


class TracerouteValidator(FQDNValidator):
    options = {"exempt_network_duplicate": "true"}


class FQDNField(TextField):
    default_validators = [FQDNValidator()]
    default_error_messages = {}

    def __init__(self,
            max_length=Fqdn.MAX_LENGTH,
            required=True,
            *args, **kwargs):
        super(FQDNField, self).__init__(
                max_length=max_length,
                required=required,
                *args, **kwargs)


class PingField(TextField):
    default_validators = [PingValidator()]
    default_error_messages = {}

    def __init__(self,
            max_length=Fqdn.MAX_LENGTH,
            required=True,
            *args, **kwargs):
        super(PingField, self).__init__(
                max_length=max_length,
                required=required,
                *args, **kwargs)


class TracerouteField(TextField):
    default_validators = [TracerouteValidator()]
    default_error_messages = {}

    def __init__(self,
            max_length=Fqdn.MAX_LENGTH,
            required=True,
            *args, **kwargs):
        super(TracerouteField, self).__init__(
                max_length=max_length,
                required=required,
                *args, **kwargs)
