# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
#from django.core import validators
from ..select import SelectField


class IPv4SubnetMaskField(SelectField):
#    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
#        }
#    default_validators = [validators.validate_ipv4_address]
    masks = (
        '',
        '255.255.255.254',
        '255.255.255.252',
        '255.255.255.248',
        '255.255.255.240',
        '255.255.255.224',
        '255.255.255.192',
        '255.255.255.128',
        '255.255.255.0',
        '255.255.254.0',
        '255.255.252.0',
        '255.255.248.0',
        '255.255.240.0',
        '255.255.224.0',
        '255.255.192.0',
        '255.255.128.0',
        '255.255.0.0',
        '255.254.0.0',
        '255.252.0.0',
        '255.248.0.0',
        '255.240.0.0',
        '255.224.0.0',
        '255.192.0.0',
        '255.128.0.0',
        '255.0.0.0',
        '254.0.0.0',
        '252.0.0.0',
        '240.0.0.0',
        '224.0.0.0',
        '192.0.0.0'
    )

    def __init__(self, initial='255.255.255.0', *args, **kwargs):
        super(IPv4SubnetMaskField, self).__init__(
                choices=((v, v) for v in self.masks),
                initial=initial,
                *args, **kwargs)
