# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django import forms
#from django.core import validators
from validators.fal import FALValidator
from fal_validinfo import IpAddress


class IPv4v6AddressValidator(FALValidator):
    validator = IpAddress.VALIDATOR
    options = {"family": "10"}


class IPv4v6AddressField(forms.CharField):
    default_validators = [IPv4v6AddressValidator()]

    def __init__(self, max_length=None, *args, **kwargs):
        super(IPv4v6AddressField, self).__init__(
                max_length=max_length,
                *args, **kwargs)
