# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from validators.fal import FALValidator
from fal_validinfo import IpAddress

class IPv6AddressValidator(FALValidator):
    validator = IpAddress.VALIDATOR
    options = {"family": "6"}


class IPv6AddressField(forms.CharField):
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid IPv6 address.'),
    }
    default_validators = [IPv6AddressValidator()]

    def __init__(self, max_length=None, *args, **kwargs):
        super(IPv6AddressField, self).__init__(
                max_length=max_length,
                *args, **kwargs)
