# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import LanDiskName


class LandiskNameValidator(FALValidator):
    validator = LanDiskName.VALIDATOR
    options = {}


class LandiskNameField(TextField):
#    widget = forms.widgets.TextInput
    default_validators = [LandiskNameValidator()]
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }

    def __init__(self,
            max_length=LanDiskName.MAX_LENGTH,
            required=True,
            *args, **kwargs):
        super(LandiskNameField, self).__init__(
                max_length=max_length,
                required=required,
                *args, **kwargs)
