# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.conf import settings


class MicrosoftNetworkMethodField(forms.ChoiceField):

    widget = forms.widgets.RadioSelect
    # default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    # }

    _choices_empty = object()
    _initial_empty = object()

    _functionlist = settings.FEATURES([u"functionlist"], default=[])
    _workgroup = True
    _nt_domain = u"nt_domain" in _functionlist
    _active_directory = u"active_directory" in _functionlist

    def __init__(self,
                 choices=_choices_empty,
                 initial=_initial_empty,
                 *args, **kwargs):
        if choices is self._choices_empty:
            choices = []
            if self._workgroup:
                choices.append((u"wg", _(u"workgroup")))
            if self._nt_domain:
                choices.append((u"nt", _(u"NT domain")))
            if self._active_directory:
                choices.append((u"ad", _(u"Active Directory")))
        if initial is self._initial_empty:
            initial = choices[0][0]
        super(MicrosoftNetworkMethodField, self).__init__(choices=choices,
                                                          initial=initial,
                                                          *args, **kwargs)
