# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.conf import settings


class MainInterfaceField(forms.ChoiceField):

    widget = forms.widgets.RadioSelect
    # default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    # }

    _choices_empty = object()
    _initial_empty = object()

    def __init__(self,
                 choices=_choices_empty,
                 initial=_initial_empty,
                 *args, **kwargs):
        if choices is self._choices_empty:
            choices = [(name, _(u"Give priority to network interface %(netif)s.") % {u"netif": name.upper()}) for name in [netif["name"] for netif in settings.NETWORK_INTERFACES if netif.get("name")]]
        if initial is self._initial_empty:
            initial = choices[0][0]
        super(MainInterfaceField, self).__init__(choices=choices,
                                                 initial=initial,
                                                 *args, **kwargs)
