# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from ..select import SelectField
from product_conf import PORT_TO_MODE_LIST
from project.fal.raidctrl import Raidctrl
from project.fal.port import Port


class PortModeField(SelectField):
    MODE = PORT_TO_MODE_LIST
#    _TO_DISP = {
#        'share': _(u'Share mode'),
#        'quickcopy': _(u'Quickcopy mode'),
#        'mirroring': _(u'Mirroring mode'),
#        'vfsext': _(u'VFS'),
#    }

    def __init__(self, devtype='usb', portnum=1, *args, **kwargs):
        modelist = list(self.MODE[devtype][portnum])
        #if Raidctrl().query().get('level', None) == 'vfsext':
        if Raidctrl().query().get('level', '').split('_')[0] == 'vfsext':
            try:
                modelist.remove('mirroring')
            except ValueError:
                pass
        else:
            try:
                modelist.remove('vfsext')
            except ValueError:
                pass
#        choices = [(mode, self._TO_DISP[mode]) \
#                for mode in modelist if mode in self._TO_DISP]
        pobj = Port()
        choices = [(mode, pobj.trans(mode)) for mode in modelist]
        super(PortModeField, self).__init__(
                choices=choices,
                *args, **kwargs)
