# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from validators.fal import FALValidator
from fal_validinfo import RemotePortNumber


class PortNumberField(forms.IntegerField):
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a whole number.'),
#        'max_value': _(u'Ensure this value is less than or equal to %(limit_value)s.'),
#        'min_value': _(u'Ensure this value is greater than or equal to %(limit_value)s.'),
    }

    def __init__(self,
            attrs=None,
            max_value=65535,
            min_value=0,
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(PortNumberField, self).__init__(
                max_value=max_value,
                min_value=min_value,
                required=required,
                widget=widget or self.widget(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)


class RemotePortNumberValidator(FALValidator):
    validator = RemotePortNumber.VALIDATOR
    options = {}


class RemotePortNumberField(forms.IntegerField):
    default_validators = [RemotePortNumberValidator()]
    default_error_messages = {
    }

    def __init__(self,
            attrs=None,
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(RemotePortNumberField, self).__init__(
                required=required,
                widget=widget or self.widget(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)
