# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import Fqdn


class ProxyHostValidator(FALValidator):
    validator = Fqdn.VALIDATOR
    options = {"exempt_network_duplidate": "true"}


class ProxyHostField(TextField):
    default_error_messages = {}
    default_validators = [ProxyHostValidator()]

    def __init__(self,
            max_length=Fqdn.MAX_LENGTH,
            required=True,
            *args, **kwargs):
        super(ProxyHostField, self).__init__(
                max_length=max_length,
                required=required,
                *args, **kwargs)
