# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from django.core.exceptions import ValidationError
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import Quota


class QuotaValidator(FALValidator):
    validator = Quota.VALIDATOR
    options = {}


class QuotaField(TextField):
#    widget = forms.widgets.TextInput
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }
    default_validators = [QuotaValidator()]

    # from django.forms.fields.IntegerField.to_pyton
    def to_python(self, value):
        value = super(QuotaField, self).to_python(value)
        if value in validators.EMPTY_VALUES:
            return None
#            return 0
        if self.localize:
            value = formats.sanitize_separators(value)
        try:
            value = int(str(value))
        except (ValueError, TypeError):
            raise ValidationError(self.error_messages['invalid'])
        return value


class QuotaLimitField(TextField):
#    widget = forms.widgets.TextInput
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }
    default_validators = [QuotaValidator()]

    def __init__(self,
            attrs={},
            initial=0.0,
            help_text='GB',
            *args, **kwargs):
        if not isinstance(attrs, dict):
            attrs = {}
        if 'size' not in attrs:
            attrs['size'] = '7'
        if 'style' not in attrs:
            attrs['style'] = 'ime-mode:disabled;'
        super(QuotaLimitField, self).__init__(
                attrs=attrs,
                initial=initial,
                help_text=help_text, *args, **kwargs)

    # from django.forms.fields.IntegerField.to_pyton
    def to_python(self, value):
        value = super(QuotaLimitField, self).to_python(value)
        if value in validators.EMPTY_VALUES:
            return 0.0
        if self.localize:
            value = formats.sanitize_separators(value)
        try:
            value = float(str(value))
        except (ValueError, TypeError):
            raise ValidationError(self.error_messages['invalid'])
        return value
