# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from ..text import TextField
from ..select import SelectField, MultiSelectField
from validators.fal import FALValidator
from project.fal.share import Share
from project.fal.raidctrl import Raidctrl


class RaidModeField(SelectField):
    #widget = forms.widgets.Select
    default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    }

    _disp = {
        'vfsext'  : _(u"VFS"),
        'vfsext_6': _(u"VFS(6)"),
        'vfsext_4': _(u"VFS(4)"),
        'vfsext_3': _(u"VFS(3)"),
        'vfsext_2': _(u"VFS(2)"),
        'raid0'   : _(u"RAID0"),
        'raid0_6' : _(u"RAID0(6)"),
        'raid0_4' : _(u"RAID0(4)"),
        'raid0_3' : _(u"RAID0(3)"),
        'raid0_2' : _(u"RAID0(2)"),
        'raid1'   : _(u"RAID1"),
        'raid1_4' : _(u"RAID1(4)"),
        'raid1_3' : _(u"RAID1(3)"),
        'raid1_2' : _(u"RAID1(2)"),
        'raid5'   : _(u"RAID5"),
        'raid5_6' : _(u"RAID5(6)"),
        'raid5_4' : _(u"RAID5(4)"),
        'raid6'   : _(u"RAID6"),
        'raid6_6' : _(u"RAID6(6)"),
        'raid6_4' : _(u"RAID6(4)"),
    }

    def _trans(self, mode):
        return self._disp.get(mode, mode)
#        return {
#            'raid6': _(u'RAID6'),
#            'raid5': _(u'RAID5'),
#            'raid1': _(u'RAID1'),
#            'raid0': _(u'RAID0'),
#            'vfsext': _(u'VFS'),
#        }.get(mode, mode)

    def raid_mode_list(self):
        return Raidctrl().getraidmode(to_list=True)

    def not_change(self):
        try:
            if Raidctrl().status(humanize=False) == 'crash':
                return False
            else:
                return True
        except:
            return True

    def __init__(self, *args, **kwargs):
        choices = [(mode, self._trans(mode)) for mode in self.raid_mode_list()]
        if self.not_change():
            choices = choices + [('', _(u'RAID not change'))]
        super(RaidModeField, self).__init__(
                choices=choices,
                *args, **kwargs)
