# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from validators.fal import FALValidator
from fal_validinfo import Url


class UrlValidator(FALValidator):
    validator = Url.VALIDATOR


class URLField(forms.CharField):
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid URL.'),
#        'invalid_link': _(u'This URL appears to be a broken link.'),
    }
    default_validators = [UrlValidator()]

    def __init__(self,
            attrs=None,
            max_length=Url.MAX_LENGTH,
            min_length=Url.MIN_LENGTH,
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(URLField, self).__init__(
                required=required,
                widget=widget or self.widget(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)
