# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core import validators
from ..text import TextField
from validators.fal import FALValidator
from fal_validinfo import UserName
from fal_validinfo import Comment


class UserNameValidator(FALValidator):
    validator = UserName.VALIDATOR
    options = {}


class UserNameField(TextField):
#    widget = forms.widgets.TextInput
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }
    default_validators = [UserNameValidator()]

    def __init__(self, max_length=UserName.MAX_LENGTH, *args, **kwargs):
        super(UserNameField, self).__init__(
                max_length=max_length,
                *args, **kwargs)


class UserFullNameValidator(FALValidator):
    validator = Comment.VALIDATOR
    options = {}


class UserFullNameField(TextField):
#    widget = forms.widgets.TextInput
    default_error_messages = {
#        'required': _(u'This field is required.'),
#        'invalid': _(u'Enter a valid value.'),
#        'max_length': _(u'Ensure this value has at most %(limit_value)d characters (it has %(show_value)d).'),
#        'min_length': _(u'Ensure this value has at least %(limit_value)d characters (it has %(show_value)d).'),
    }
    default_validators = [UserFullNameValidator()]

    def __init__(self, max_length=Comment.MAX_COUNT, *args, **kwargs):
        super(UserFullNameField, self).__init__(
                max_length=max_length,
                *args, **kwargs)
