# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.core.exceptions import ValidationError
from project.fal.command import get_message, escape
try:
    from fal_info import FAL_VALIDATE_PATH
except:
    FAL_VALIDATE_PATH = '/mnt/data/bin/fal_validate.py'


class FALValidator(object):
    falv = FAL_VALIDATE_PATH

    validator = None
    options = {
#        'not_null': 'true',  # sample
    }

    def __init__(self, validator=None, options=None):
        self.validator = validator or self.validator
        self.options = options or self.options

    def _to_xml(self, value):
        return escape(value)

    def __call__(self, value):
        try:
            from ionas.request import Request, Entry
            xml = """<validate>
                <target validator="%(validator)s" %(opts)s>%(value)s</target>
            </validate>""" % {
                'validator': self.validator,
                'opts': ' '.join([''] + ['%s="%s"' % (k, v) for k, v in self.options.iteritems()]),
                'value': self._to_xml(value),
            }
            response = Request(self.falv, filter_cmd='sudo').request(
                    Entry('validate', xml))
            entry = response.get_entrylist().get_entry()
            validate = entry.get()
            result = validate.get_node('result')
            messageinfo = None
            try:
                messageinfo = result.get_node('messageinfo')
            except:  # FIXME NotFoundError
                pass
            if messageinfo:
                # FIXME code はまだしも arglist が少し複雑 再考の余地有
                code = messageinfo.get_node('code').get_text()
                arglist = dict([(n.get_attrs()['name'], n.get_text()) \
                        for n in messageinfo.get_node_list('arglist/arg')])
                raise ValidationError(get_message(code, arglist))
        except ValidationError, e:
            raise
        except:
#            import traceback
#            open("/tmp/validate", "a").write(traceback.format_exc())
            raise ValidationError(_(u'UnknownError'))


if __name__ == '__main__':
    v = FALValidator()
    v('landisk-123456')
