# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from ..checkbox import MultiCheckboxField


class MultiWeekdayField(MultiCheckboxField):

    __choices = (
        (u'Sun', _(u'Sunday')),
        (u'Mon', _(u'Monday')),
        (u'Tue', _(u'Tuesday')),
        (u'Wed', _(u'Wednesday')),
        (u'Thu', _(u'Thursday')),
        (u'Fri', _(u'Friday')),
        (u'Sat', _(u'Saturday')),
    )

    def __init__(self, initial=None, choices=None, *args, **kwargs):
        super(MultiWeekdayField, self).__init__(
                choices=choices or self.__choices,
                initial=initial or [],
                *args, **kwargs)
