# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
#from django.utils.translation import ugettext as _
from django import forms
from django.utils.safestring import mark_safe
from django.utils.encoding import force_unicode


class RadioField(forms.ChoiceField):
    widget = forms.widgets.RadioSelect
    #default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    #    }

    # 各選択肢を横並びにする (デフォルトは縦並び)
    class Renderer(forms.widgets.RadioFieldRenderer):
        def render(self):
            return mark_safe(u'%s' % u''.join([force_unicode(w) for w in self]))

    def __init__(self,
            choices=(),
            attrs=None,
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(RadioField, self).__init__(
                choices=choices,
                required=required,
                widget=widget or forms.widgets.RadioSelect(
                        renderer=self.Renderer,
                        attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)
