# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
#from django.utils.translation import ugettext as _
from django import forms
from django.utils.encoding import force_unicode
from django.utils.html import escape, conditional_escape


class SelectMultipleWithTitle(forms.widgets.SelectMultiple):
    def render_option(self, selected_choices, option_value, option_label):
        option_value = force_unicode(option_value)
        if option_value in selected_choices:
            selected_html = u' selected="selected"'
            if not self.allow_multiple_selected:
                # Only allow for a single selection.
                selected_choices.remove(option_value)
        else:
            selected_html = ''
        return u'<option title="%s" value="%s"%s>%s</option>' % (
            conditional_escape(force_unicode(option_label)),
            escape(option_value),
            selected_html,
            conditional_escape(force_unicode(option_label)))
#        return u'<option value="%s"%s>%s</option>' % (
#            escape(option_value), selected_html,
#            conditional_escape(force_unicode(option_label)))


class SelectField(forms.ChoiceField):
    #widget = forms.widgets.Select
    #default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    #    }
    def __init__(self,
            attrs=None,
            choices=(),
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(SelectField, self).__init__(
                choices=choices,
                required=required,
                widget=forms.widgets.Select(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)


class MultiSelectField(forms.MultipleChoiceField):
    #widget = forms.widgets.SelectMultiple
    widget = SelectMultipleWithTitle
    #default_validators = []
    default_error_message = {
    #    'required': _(u'This field is required.'),
    #    'invalid': _(u'Enter a valid value.'),
    #    'invalid_choice': _(u'Select a valid choice. %(value)s is not one of the available choices.'),
    #    'invalid_list': _(u'Enter a list of values.'),
        }
    def __init__(self,
            attrs=None,
            choices=(),
            required=True,
            widget=None,
            label=None,
            initial=None,
            help_text=None,
            *args, **kwargs):
        super(MultiSelectField, self).__init__(
                choices=choices,
                required=required,
                widget=widget or self.widget(attrs=attrs),
                label=label,
                initial=initial,
                help_text=help_text,
                *args, **kwargs)
