# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import os
import sys
import re
import inspect


def importer(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod

def to_importable(mod_path):
    for path in sys.path:
        if re.match('^' + path, mod_path):
            return re.sub('(.py|.pyc)$', '', mod_path).replace(path + os.sep, '').replace(os.sep, '.')
    raise

def pwd():
    return os.path.dirname(inspect.currentframe().f_back.f_code.co_filename)

def is_django_app(dpath):
    if not os.path.isdir(dpath):
        return False
    if os.path.exists(os.path.join(dpath, 'models.py')):
        return True
    if os.path.exists(os.path.join(dpath, 'models.pyc')):
        return True
    return False

def is_crash():
    try:
        from project.fal.statemgr import Statemgr
        return Statemgr().is_raidcrash()
    except:
        return False

def is_keywait():
    try:
        from project.fal.statemgr import Statemgr
        return Statemgr().is_keywaiting()
    except:
        return False

def get_series(default=None):
    try:
        from product_conf import SUDO_CMD
        from ionas.request import Request, Entry, EntryList
        from fal_info import FAL_SYSINFO_PATH
        request = Request(FAL_SYSINFO_PATH, filter_cmd=SUDO_CMD)
        response = request.request(Entry("query", """<sysinfo />"""))
        return response.get_entrylist().get_entry().get().get_value("series", default)
    except:
        return default

def get_mirroring_device(default=(u"usb", 3)):
    try:
        from product_conf import PORT_TO_MODE_LIST
        for typ, ports in PORT_TO_MODE_LIST.iteritems():
            for i, modelist in ports.iteritems():
                if u"mirroring" in modelist:
                    return (unicode(typ), int(i))
        return default
    except:
        return default


if __name__ == u"__main__":
    print get_mirroring_device()
