# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf.urls import patterns, include, url
from django.http import HttpResponseRedirect
import settings
from root.modules.utils import pwd, is_django_app
from ..urls import add
import views
import os


def __anti_virus_software_is_installed():
    current = pwd()
    for item in os.listdir(current):
        path = os.path.join(current, item)
        if os.path.isdir(path):
            if is_django_app(path):
                return True
    return False


AntiVirusView = views.AntiVirusMenuView
if not __anti_virus_software_is_installed():
    AntiVirusView = views.AntiVirusView

if settings.IS_ENABLE:
    urlpatterns = patterns(
        '',
        url(r'^$', lambda r: HttpResponseRedirect('./antivirus')),
        url(r'^antivirus$', AntiVirusView.as_view()),
    )
    add(urlpatterns, pwd())
else:
    urlpatterns = patterns('',)
