# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message


def root(request):
    return HttpResponseRedirect('./announce')


class View(FuncView):
    from ..modules.info import Information
    views = ['clear']
    info = Information()

    def view(self, request):
        mesgs = self.info.get_announces()
        self.info.announces_clear()
        return {self.KEY_TEMPLATE: self.TEMPLATE,
                self.KEY_TEMPLATE_DIC: {
                    'mesgs': mesgs,
                    'nums': len(mesgs)}}

    def view_clear(self, request):
        with self.processing(constname="ERR_ANNOUNCE_STATE_CHANGE") as p:
            rst = False
            p.break_if_state_change()

            if self.info.announces_clear(level="all"):
                self.set_message(get_message('MSG_ANNOUNCE_CLEAR', is_log=True))
                rst = True
            else:
                self.set_message(get_message('ERR_ANNOUNCE_CLEAR', is_log=True))
            p.result(rst)

        return {self.KEY_REDIRECT: "/".join([".", "announce"])}


announce = View.as_view()
