# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf import settings
from django.http import HttpResponseRedirect
#from root.modules.view import FuncView
from project.view import FuncView
from ..modules.info import (Information, INET4, INET6)


def root(request):
    return HttpResponseRedirect('./nwinfo')


class View(FuncView):
    info = Information()

    def view(self, request):
        query_info = self.info.query_network_info()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                "LAN2_IS_SUPPORTED": settings.LAN2_IS_SUPPORTED,
                'host': self.info.get_host_info(),
                'ipv4': self.info.get_tcpip_info(query_info, aftype=INET4),
                'ipv6': self.info.get_tcpip_info(query_info, aftype=INET6),
                'proxy': self.info.get_proxy_info(),
                'msnetwork': self.info.get_msnetwork_info(),
            },
        }


nwinfo = View.as_view()
