# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf import settings
from django.http import HttpResponseRedirect
from project.view import FuncView
from django.utils.translation import ugettext as _


def root(request):
    return HttpResponseRedirect('./volumeinfo')


class View(FuncView):
    from ..modules.info import Information
    info = Information()

    def __get_volume_info_dic(self):
        volume_dic = {}
        status_dict = {
                'normal': _(u'Normal'),
                'fail': _(u'Fail'),
                'failpending': _(u'FailPending'),
                'smarterror': _(u'SmartError'),
                'capshortage': _(u'CapShortage'),
                'smarterrorpending': _(u'SmartErrorPending'),
                'unplug': _(u'Unconnected'),
                'unconnected': _(u'Unconnected'),
        }
        #usblist = ["usb1", "usb2", "usb3", "usb4"]
        usblist = ["usb%s" % usb["port"] for usb in settings.FEATURES(["deviceinfo", "usblist"]) if usb.get("port")]
        for name in ["internal"] + usblist:
            volume_dic[name] = self.info.get_volume_info(name)
            volume_dic[name]['name'] = name
            if name == "internal":
                from project.fal.raidctrl import Raidctrl
                volume_dic["internal"]["mode"] = \
                        Raidctrl().trans(volume_dic["internal"]["mode"])
                diskinfo = volume_dic["internal"]["disks"]
                for val in diskinfo.values():
                    val["status"] = status_dict.get(val["status"])
        volume_dic['usblist'] = [volume_dic[usb] for usb in sorted(usblist)]

        return volume_dic 

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: self.__get_volume_info_dic()}


volumeinfo = View.as_view()
