# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

import time
from datetime import datetime

from django.utils.translation import ugettext as _
from django.http import HttpResponse
from django.utils import simplejson
from project.view import RootView
from project.fal.lumpregist import LumpRegist

RESULT_FMT = "(%s)"
TIMESTAMP_FMT = "/%s"

STATUS_TABLE = {
    "NOT_EXEC": _(u"Not Execute"),
    "ABORT": _(u"Abort"),
    "COMPLETE": _(u"Complete"),
    "PROCESSING": _(u"Processing")}


class StatusView(RootView):

    def view(self, request):
        return {self.KEY_RESPONSE: HttpResponse(
                simplejson.dumps({'status': self._status()}),
                mimetype="application/json; charset=UTF-8;")}

    def _node_to_str(self, node):
        status = STATUS_TABLE.get(node.get_value("status", ""), "")
        timestamp = node.get_value("timestamp", "")  # epoch
        if timestamp:
            timestamp = TIMESTAMP_FMT % unicode(
                datetime(*time.localtime(int(timestamp))[:6]))
        return status + timestamp

    def _status(self):
        try:
            result = self._node_to_str(LumpRegist().query().get())
        except:
            result = ""
        return result
