# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
import settings
from .. import settings as ps


def root(request):
    return HttpResponseRedirect('/'.join([settings.MENU_URL, 'delete']))


class View(FuncView):
    from ..modules.backup import Backup
    views = ['delete', 'list']
    backup = Backup()

    def view(self, request, id):
        init_info = self.backup.delete_or_execute_init_info(id)
        if not init_info:
            return {self.KEY_REDIRECT:
                "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}

        self.session["jobname"] = init_info.get("name")
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'info': init_info}}

    def view_delete(self, request, id):
        with self.processing(constname="ERR_BACKUP_STATE_CHANGE") as p:
            rst = False
            p.break_if_state_change()

            jobname = self.session.get("jobname")
            if not jobname:
                jobname = id

            if self.backup.delete_job(id):
                self.set_message(get_message('MSG_BACKUP_DELETE',
                    arglist={"name": jobname}, is_log=True))
                rst = True
            else:
                self.set_message(get_message('ERR_BACKUP_DELETE',
                    arglist={"name": jobname}, is_log=True))
            p.result(rst)
        self.session.clear()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {}}

    def view_list(self, request, id):
        return {self.KEY_REDIRECT:
                "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}

delete = View.as_view()
