# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from project.fal.backups import Backups
from project.forms.fields.extras.backuphistory import SelectBackupHistoryField
from root.modules.form import BaseForm
import settings
from .. import settings as ps
from ... modules.status_view import StatusView


class RestoreForm(BaseForm):
    def __init__(self, jobno, *args, **kwargs):
        super(RestoreForm, self).__init__(*args, **kwargs)
        self.fields['history'] = SelectBackupHistoryField(
                jobno,
                label=_(u'Backup History'))

class View(FuncView):
    views = ['execute']

    def __jobno_to_info(self, jobno):
        try:
            info = Backups().load()['backup'][str(jobno)]
            info['id'] = jobno
            return info
        except:
            return None

    def view(self, req, jobno=None):
        # FIXME check jobno
        form = RestoreForm(jobno)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'status': StatusView()._status(id=jobno),
                'job': self.__jobno_to_info(jobno),
                'form': form}}

    def view_execute(self, req, jobno=None):
        from project.fal.led import LED
        from project.fal.buzzer import Buzzer
        LED().status(True, blink=True, color='green')

        result = False
        job = self.__jobno_to_info(jobno)
        form = RestoreForm(jobno, data=req.POST)
        if form.is_valid():
            backup = Backups()
            result = backup.restore(jobno, form.cleaned_data['history'], name=job['name'])
            self.set_message(backup.get_message())
        
        LED().status(True, blink=False, color='green')
        if result:
            Buzzer().ok()
        else:
            Buzzer().error()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'status': StatusView()._status(id=jobno),
                'job': job,
                'form': form}}


class StatusView(StatusView):
    CATEGORY = 'restore'
