# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponse, HttpResponseRedirect
from django.utils import simplejson
from project.view import RootView, MenuView
from project.fal.backups import Backups
import settings


def root(request):
    return HttpResponseRedirect('./menu')


class MenuView(MenuView):
    pass


class RunningView(RootView):

    def view(self, request):
        running = {
        #   'jobid': True/False,
        }
        try:
            backup = Backups()
            for jid, jprm in backup.query()['backup'].iteritems():
                running[jid] = jprm['status'] in ['PROCESSING', 'QUEUE']
#            for jid in backup.query()['backup'].keys():
#                running[jid] = backup.is_running(jid)
        except:
            pass
        return {
            self.KEY_RESPONSE: HttpResponse(
                    simplejson.dumps(running),
                    mimetype="application/json;charset=UTF-8;"),
        }


class ProcessingView(RootView):

    def view(self, request, function=None):
        functions = ("backup", "restore") if function is None else function
        processing = {
        #   'jobid': True/False,
        }
        try:
            data = Backups().query()
            for _function in functions:
                for jobid, param in data.get(_function, {}).iteritems():
                    processing[jobid] = processing.get(jobid) or param.get("status") in ("PROCESSING", "QUEUE")
        except:
            pass
        return {
            self.KEY_RESPONSE: HttpResponse(simplejson.dumps(processing),
                                            mimetype="application/json;charset=UTF-8;"),
        }


menu = MenuView.as_view()
