# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from .. import settings as ps
from ...modules.unc import LocalListView, NetworkListView

MAX_JOB_NUM = 20


def root(request):
    return HttpResponseRedirect('./add')

class View(FuncView):
    from ..modules.form import Form 
    from ..modules.datacopy import Datacp
    views = ['add', 'list']

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': self.Form()}}

    def view_add(self, request):
        with self.processing(constname="ERR_DATACOPY_STATE_CHANGE") as p:
            form = self.Form(data=request.POST)
            rst = False
            p.break_if_state_change()

            if form.is_valid():
                clean_data = form.cleaned_data
                datacp = self.Datacp()
                joblist = datacp.get_job_list()
                if len(joblist) < MAX_JOB_NUM:
                    if datacp.add_job(clean_data):
                        self.set_message(get_message('MSG_DATACOPY_ADD',
                            arglist={"name": clean_data.get("name")},
                            is_log=True))
                        rst = True
                    else:
                        self.set_message(get_message('ERR_DATACOPY_ADD',
                            arglist={"name": clean_data.get("name")},
                            is_log=True))
                else:
                    self.set_message(get_message('ERR_DATACOPY_JOB_NO_MORE',
                        arglist={"name": clean_data.get("name")}, is_log=True))
                p.result(rst)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': form}}

    def view_list(self, request):
        return {
            self.KEY_REDIRECT:
            "/".join(["..", ps.LIST_APPLI, ps.LIST_VIEW])}


add = View.as_view()
locallist = LocalListView.as_view()
networklist = NetworkListView.as_view()
