# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from ..modules.form import Form as DatacpSettingForm
from ...modules.unc import LocalListView, NetworkListView

from .. import settings as ps


def root(request):
    return HttpResponseRedirect('./modify')


class Form(DatacpSettingForm):
    def __init__(self, id=None, *args, **kwargs):
        super(Form, self).__init__(id, *args, **kwargs)


class View(FuncView):
    from ..modules.datacopy import Datacp
    views = ['modify', 'list']
    datacp = Datacp()

    def view(self, request, id):
        init_info = self.datacp.modify_init_info(id)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': Form(initial=init_info)}}

    def view_modify(self, request, id):
        with self.processing(constname="ERR_DATACOPY_STATE_CHANGE") as p:
            form = Form(data=request.POST, id=id)
            rst = False
            p.break_if_state_change()

            if form.is_valid():
                data = form.cleaned_data
                init_info = self.datacp.modify_init_info(id)
                if init_info.get("name"):
                    name = init_info.get("name")
                else:
                    name = data.get("name")
                if self.datacp.modify_job(data, id):
                    self.set_message(get_message('MSG_DATACOPY_MODIFY',
                        arglist={"name": name}, is_log=True))
                    rst = True
                else:
                    self.set_message(get_message('ERR_DATACOPY_MODIFY',
                        arglist={"name": name}, is_log=True))
                p.result(rst)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}

    def view_list(self, request, id):
        return {
            self.KEY_REDIRECT:
            "/".join(["..", "..", ps.LIST_APPLI, ps.LIST_VIEW])}


modify = View.as_view()
locallist = LocalListView.as_view()
networklist = NetworkListView.as_view()
