# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import json
from ionas.request import (Request, Entry)
from django.http import HttpResponse
from django.utils.translation import ugettext as _
from project.view import FuncView
from product_conf import SUDO_CMD
from fal_info import (FAL_MSNETWORK_PATH, FAL_SYSINFO_PATH, ReqTypes, Results)
from share_ctrl import ShareCtrl

LIST_ENTRY = "<msnetwork/>"
HOST_XPATH = "./domainlist/domain/hostlist/host"
SHARE_XPATH = "./sharelist/share/name"


class LocalList(object):
    #バックアップ先/元のUNCを取得して、jsonのデータでhtmlへ渡す。

    def sharelist(self):
        local_list = ShareCtrl().get_local_share_list()
        
        return HttpResponse(
            json.dumps({"local": local_list}),
            mimetype="application/json; charset=UTF-8;")


class NetworkList(object):
    #バックアップ先/元のUNCを取得して、jsonのデータでhtmlへ渡す。
    def sharelist(self):
        unc_data = Request(FAL_MSNETWORK_PATH, filter_cmd=SUDO_CMD).request(
                  Entry(ReqTypes.LIST, LIST_ENTRY)).get_entrylist().get_entry()
        data_dic = {}
        if unc_data.get_result() == Results.OK:
            sysinfo = Request(FAL_SYSINFO_PATH, filter_cmd=SUDO_CMD).request(
                          Entry(ReqTypes.QUERY)).get_entrylist().get_entry()
            local_name = sysinfo.get().get_node("hostdesc/name").get_text()
            host_name_list = []
            nw_list = []
            for node in unc_data.get().get_node_list(HOST_XPATH):
                host_name = node.get_node("name").get_text()
                if host_name in host_name_list:
                    continue
                for share in node.get_node_list(SHARE_XPATH):
                    share_name = share.get_text()
                    if host_name != local_name.upper():
                        nw_list.append("\\\\" + host_name + "\\" + share_name)
                host_name_list.append(host_name)
            nw_list.sort()

        return HttpResponse(
            json.dumps({"network": nw_list}),
            mimetype="application/json; charset=UTF-8;")


class LocalListView(FuncView):
    def get_sharelist(self):
        list = LocalList()
        return list.sharelist()

    def view(self, request):
        return {self.KEY_RESPONSE: self.get_sharelist()}


class NetworkListView(FuncView):
    def get_sharelist(self):
        list = NetworkList()
        return list.sharelist()

    def view(self, request):
        return {self.KEY_RESPONSE: self.get_sharelist()}
