# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from ionas.request import (Request, Entry)
from product_conf import SUDO_CMD
from fal_info import (FAL_PROXY_PATH, ReqTypes, Results)

PROXY_ENTRY = "<proxy><manual><host/><port/></manual><pacfile><url/></pacfile></proxy>"


class Proxy(object):
    def send_request(self, req_entry):
        try:
            response = Request(FAL_PROXY_PATH, filter_cmd=SUDO_CMD).request(req_entry)
            if response.get_entrylist().get_entry().get_result() == Results.OK:
                return True
            else:
                return False
        except:
            # FIXME  例外種類ごとに、ユーザにメッセージを渡す？
            # 検討必要
            return False

    def get_init_config(self):
        info = {}
        config = Request(FAL_PROXY_PATH, filter_cmd=SUDO_CMD).request(
                        Entry(ReqTypes.LOAD)).get_entrylist().get_entry().get()
        if config.get_attr_value("enable") == "true":
            manual = config.get_node("manual")
            pacfile = config.get_node("pacfile")
            if manual.is_enabled():
                info["proxy_set"] = "manual"
                info["host"] = manual.get_node("host").get_text()
                info["port"] = manual.get_node("port").get_text()
            elif pacfile.is_enabled():
                info["proxy_set"] = "pacfile"
                info["url"] = pacfile.get_node("url").get_text()
        else:
            info["proxy_set"] = "disable"
        return info 

    def proxy_set(self, data):
        entry = Entry(ReqTypes.SAVE, PROXY_ENTRY)
        if data["proxy_set"] == "manual":
            entry.get().set_attrs({"enable": "true"})
            entry.get().get_node("manual").set_attrs({"enable": "true"})
            entry.get().get_node("manual/host").set_text(data["host"])
            entry.get().get_node("manual/port").set_text(str(data["port"]))
        elif data["proxy_set"] == "pacfile":
            entry.get().set_attrs({"enable": "true"})
            entry.get().get_node("pacfile").set_attrs({"enable": "true"})
            entry.get().get_node("pacfile/url").set_text(data["url"])
        else:
            entry.get().set_attrs({"enable": "false"})
            entry.get().get_node("manual").set_attrs({"enable": "false"})
            entry.get().get_node("pacfile").set_attrs({"enable": "false"})
        return self.send_request(entry)
