#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

import os
import sys
import inspect

F_NAME_IDX = 0
F_OBJ_IDX = 1
PREFIX = "is_disabled_"
NO_MOD_LIST = ["__init__.py"]


sys.path.append(os.path.dirname(__file__))

for mod_file in os.listdir(os.path.dirname(__file__)):
    if not mod_file.endswith(".py"):
        continue
    if mod_file in NO_MOD_LIST:
        continue

    mod_name = os.path.splitext(mod_file)[0]

    mod = __import__(mod_name, globals(), locals(), [])

    func_list = inspect.getmembers(mod, inspect.isfunction)
    _get_func_list = [c for c in func_list if c[F_NAME_IDX].startswith(PREFIX)]

    if not _get_func_list:
        continue

    for _get_func in _get_func_list:
        locals()[_get_func[F_NAME_IDX]] = _get_func[F_OBJ_IDX]
