#!/usr/bin/env python
# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from ..utils import BaseMeans



class MSShare(BaseMeans):
    PATH = "shareservice/msshare/@enable"


class Hidden(BaseMeans):
    PATH = "shareservice/msshare/hidden/@enable"


class Trash(BaseMeans):
    PATH = "shareservice/msshare/trash/@enable"


class QuotaLimit(BaseMeans):
    PATH = "shareservice/msshare/quota/limit"
    IS_BOOL = False
    DEFAULT = "0.0"

    def set(self, node, val, path=""):
        if val == None:
            val = self.DEFAULT
        super(QuotaLimit, self).set(node, val, path)


means = {
    "msshare": MSShare(),
    "hidden": Hidden(),
    "trash": Trash(),
    "quota_limit": QuotaLimit(),
}
