# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from root.modules.form import BaseForm
from ..modules.protocol import Protocol



def root(request):
    return HttpResponseRedirect('./msnetwork')


class Form(BaseForm):
    def __init__(self, *args, **kwargs):
        from root.modules.form.fields.radio import RadioField
        super(Form, self).__init__(*args, **kwargs)
    
        self.fields["msnetwork"] = RadioField(
                label=_(u'Microsoft Network'),
                initial=1,
                required=True,
                validators=[])

class View(FuncView):
    views = ['apply']
    protocol = Protocol()

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': Form(initial=self.protocol.get_msnetwork_config())}}

    def view_apply(self, request):
        with self.processing(constname="ERR_MS_NET_STATE_CHANGE") as p:
            form = Form(data=request.POST)
            rst = False
            p.break_if_state_change()

            if form.is_valid():
                if self.protocol.msnetwork_set(data=form.cleaned_data):
                    self.set_message(
                            get_message('MSG_MS_NET_CHANGE', is_log=True))
                    rst = True
                else:
                    self.set_message(
                            get_message('ERR_MS_NET_CHANGE', is_log=True))
                p.result(rst)

        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}


msnetwork = View.as_view()
