# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from root.modules.form import BaseForm
import settings

FUNC = "func"


def root(request):
    return HttpResponseRedirect('/'.join([settings.MENU_URL, 'func']))
    
class View(FuncView):
    from ..modules.button import Button
    class Form(BaseForm):
        from root.modules.form.fields.radio import RadioField
        enable = RadioField(
                label=_(u'FUNC Button:'),  # FIXME
                initial=1,
                required=True,
                validators=[])

    views = ['apply']
    button = Button()

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': self.Form(
                    initial=self.button.get_config_init(FUNC))}}

    def view_apply(self, request):
        with self.processing(constname="ERR_SWITCH_STATE_CHANGE") as p:
            form = self.Form(data=request.POST)
            rst = False
            p.break_if_state_change()

            if form.is_valid():
                if self.button.send_request(FUNC, data=form.cleaned_data):
                    self.set_message(
                        get_message('MSG_SWITCH_CHANGE', is_log=True))
                    rst = True
                else:
                    self.set_message(
                        get_message('ERR_SWITCH_CHANGE', is_log=True))
                p.result(rst)

        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}

func = View.as_view()
