# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from iobase.exception import NotFoundError
from ionas.request import (Request, Entry)
from product_conf import SUDO_CMD
from fal_info import (FAL_SWITCH_PATH, ReqTypes, Results)


ENABLE = "enable"


class Button(object):
    def send_request(self, button, data):
        enable_dic = {"1": True, "0": False}
        try:
            config = Request(FAL_SWITCH_PATH, filter_cmd=SUDO_CMD).request(
                    Entry(ReqTypes.LOAD)).get_entrylist().get_entry().get()
            config.get_node(button).enable(true=enable_dic[data[ENABLE]])
            entry = Entry(ReqTypes.SAVE, config)
            response = Request(FAL_SWITCH_PATH, filter_cmd=SUDO_CMD).request(
                       entry).get_entrylist().get_entry()
            if response.get_result() == Results.OK:
                return True
            else:
                return False
        except:
            return False

    def get_config_init(self, button):
        init = {ENABLE: 1}
        try:
            result = Request(FAL_SWITCH_PATH, filter_cmd=SUDO_CMD).request(
                    Entry(ReqTypes.LOAD)).get_entrylist().get_entry()
        except:
            return init     #FIXME
        try:
            if not result.get().get_node(button).is_enabled():
                init[ENABLE] = 0
        except NotFoundError:
            pass
        return init
