# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from root.modules.form import BaseForm
import settings
from root.modules.form.fields.radio import RadioField
from root.modules.form.fields.select import SelectField
 
AUTO = "autoupdate"


def root(request):
    return HttpResponseRedirect('/'.join([settings.MENU_URL, 'auto']))

class View(FuncView):
    from ..modules.firmware import Firmware
    class Form(BaseForm):
        time_choices = []
        for num in range(0, 24):
            time_choices.append((str(num), str(num)))

        autoupdate = RadioField(
                label=_(u'Auto Update'),
                initial=0,
                required=True,
                validators=[])
        time = SelectField(
                choices=tuple(time_choices),
                label=_(u'Time'),
                initial=None,
                required=False,
                validators=[])

    views = ['apply']
    firm = Firmware()

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': self.Form(initial=self.firm.get_config_init(AUTO))}}

    def view_apply(self, request):
        with self.processing(constname="ERR_FIRMWARE_STATE_CHANGE") as p:
            form = self.Form(data=request.POST)
            rst = False
            p.break_if_state_change()

            if form.is_valid():
                if self.firm.apply_request(AUTO, data=form.cleaned_data):
                    self.set_message(
                            get_message('MSG_FIRMWARE_CHANGE', is_log=True))
                    rst = True
                else:
                    self.set_message(
                            get_message('ERR_FIRMWARE_CHANGE', is_log=True))
                p.result(rst)

        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}

auto = View.as_view()
