# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from root.modules.form import BaseForm


def root(request):
    return HttpResponseRedirect('./autoupdate')


class View(FuncView):
    from ..modules.package import Package

    class Form(BaseForm):
        from root.modules.form.fields.radio import RadioField
        from root.modules.form.fields.select import SelectField
        time_choices = []
        for num in range(0, 24):
            time_choices.append((str(num), str(num)))

        auto = RadioField(
                label=_(u'Auto Update'),
                initial=0,
                required=True,
                validators=[])
        time = SelectField(
                choices=tuple(time_choices),
                label=_(u'Time'),
                initial=None,
                required=False,
                validators=[])

    views = ['apply']
    package = Package()

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': self.Form(initial=self.package.get_auto_init_info())}}

    def view_apply(self, request):
        with self.processing(constname="ERR_PKG_STATE_CHANGE") as p:
            form = self.Form(data=request.POST)
            rst = False
            p.break_if_state_change()

            if form.is_valid():
                if self.package.auto_set(form.cleaned_data):
                    self.set_message(get_message('MSG_PKG_CHANGE', is_log=True))
                    rst = True
                else:
                    self.set_message(get_message('ERR_PKG_CHANGE', is_log=True))
                p.result(rst)

        return {self.KEY_TEMPLATE: self.TEMPLATE,
                self.KEY_TEMPLATE_DIC: {'form': form}}


autoupdate = View.as_view()
