# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from .. import settings as ps


def root(request):
    return HttpResponseRedirect('./delete')


class View(FuncView):
    from ..modules.package import Package
    views = ["delete", "list"]
    package = Package()

    def view(self, request, id):
        infos = self.package.get_package_info_by_id(id)
        if not infos.get("name"):
            return {self.KEY_REDIRECT:
                "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}
        return {self.KEY_TEMPLATE: self.TEMPLATE,
                self.KEY_TEMPLATE_DIC: {'infos': infos}}

    def view_delete(self, request, id):
        with self.processing(constname="ERR_PKG_STATE_CHANGE") as p:
            rst = False
            p.break_if_state_change()

            if self.package.uninstall_package([id]):
                self.set_message(get_message('MSG_PKG_UNINSTALL', is_log=True))
                rst = True
            else:
                self.set_message(get_message('ERR_PKG_UNINSTALL', is_log=True))
            p.result(rst)

        return {self.KEY_TEMPLATE: self.TEMPLATE,
                self.KEY_TEMPLATE_DIC: {}}

    def view_list(self, request, id):
        return {self.KEY_REDIRECT:
                "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}


delete = View.as_view()
