# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
#from root.modules.view import FuncView
from project.view import FuncView
from root.modules.form import BaseForm
from project.forms.fields.extras.enable import EnableField
from project.fal.power import Power
import settings


def root(request):
    return HttpResponseRedirect('./ac')
#    return HttpResponseRedirect('/'.join([settings.MENU_URL, 'ac']))
    
class View(FuncView):
    class Form(BaseForm):
        enable = EnableField(label=_(u'ac setting'), initial=True)

    views = ['apply']

    def view(self, request):
        power = Power()
        power.load()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': self.Form(initial={
                'enable': power.TEXT_TO_BOOL[power.get_value('autoresume/@enable', False)]})}}

    def view_apply(self, request):
        with self.processing(constname='ERR_POWER_STATE_CHANGE') as p:
            form = self.Form(data=request.POST)
            p.break_if_state_change()

            if form.is_valid():
                power = Power()
                power.apply(autoresume=form.cleaned_data.get('enable', False))
                self.set_message(power.get_message())
                p.result(power.get_result(boolean=True))
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}


ac = View.as_view()
