# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import os
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from root.modules.form import BaseForm
from fal_info import Results
from project.fal.power import Power
import settings


def root(request):
    return HttpResponseRedirect('/'.join([settings.MENU_URL, 'shutdown']))


class ShutdownView(FuncView):
    views = ['shutdown', 'reboot']

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {}}

    def view_shutdown(self, request):
        return {
            self.KEY_REDIRECT: "/".join([
                settings.MENU_URL, "shutdownconfirm"])}

    def view_reboot(self, request):
        return {
            self.KEY_REDIRECT: "/".join([
                settings.MENU_URL, "rebootconfirm"])}


class ShutdownConfirmView(FuncView):
    views = ['execute', 'cancel']

    def view(self, request):
        return {
            self.KEY_TEMPLATE: os.path.join(
                    self.TEMPLATES, "shutdownconfirm.html"),
            self.KEY_TEMPLATE_DIC: {}}

    def view_execute(self, request):
        power = Power()

        self.set_message(get_message('MSG_POWER_SHUTDOWN', is_log=True))
        power.shutdown(force=True)

        return {
            self.KEY_TEMPLATE: self.TEMPLATES,
            self.KEY_TEMPLATE_DIC: {}}

    def view_cancel(self, request):
        return {
            self.KEY_REDIRECT: os.path.join(settings.MENU_URL, "shutdown"),
            self.KEY_TEMPLATE_DIC: {}}


class RebootConfirmView(FuncView):
    views = ['execute', 'cancel']

    def view(self, request):
        return {
            self.KEY_TEMPLATE: os.path.join(
                self.TEMPLATES, "rebootconfirm.html"),
            self.KEY_TEMPLATE_DIC: {}}

    def view_execute(self, request):
        power = Power()

        self.set_message(get_message('MSG_POWER_REBOOT', is_log=True))
        power.reboot(force=True)

        return {
            self.KEY_TEMPLATE: self.TEMPLATES,
            self.KEY_TEMPLATE_DIC: {}}

    def view_cancel(self, request):
        return {
            self.KEY_REDIRECT: os.path.join(settings.MENU_URL, "shutdown"),
            self.KEY_TEMPLATE_DIC: {}}


shutdown = ShutdownView.as_view()
shutdownconfirm = ShutdownConfirmView.as_view()
rebootconfirm = RebootConfirmView.as_view()
