# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
#from root.modules.view import FuncView
#from project.view import FuncView
from root.modules.view import StatusView
from root.modules.form import BaseForm
from project.forms.fields.checkbox import CheckboxField
from datetime import datetime
import time
import os
import sys

from project.fal.selfcheck import SelfCheck

NAME = _(u'Check')  # sample
NUM = 100  # sample


class Check(object):
    NAME = 'name'
    XML_FMT_CHECK_TAG = '<check name="%(NAME)s" enable="%(ENABLE)s" />'

    def run(self, cleaned_data):
        check_tag = self.XML_FMT_CHECK_TAG % dict(
                cleaned_data,
                NAME=self.NAME,
                ENABLE=str(cleaned_data.get('ENABLE', False)).lower())
        check = SelfCheck()
        return check.run(check_tag)

    def status(self):
        check = SelfCheck()
        check.query()
        return check.get_value(
                'checklist/check[@name="%s"]/status' % self.NAME, '')

    def result(self):
        chk = SelfCheck()
        chk.query()
        epoch = chk.get_value(
                'checklist/check[@name="%s"]/timestamp' % self.NAME, 0)
        if epoch:
            timestamp = datetime(*time.localtime(int(epoch))[:6])
        else:
            timestamp = ""

        result = chk.get_value(
                'checklist/check[@name="%s"]/result' % self.NAME, '')
        return u"(%s: %s)\n%s" % (
                _(u'Last Update'),
                unicode(timestamp),
                result.decode('utf-8'))


class Form(BaseForm):  # 継承して Form 作る
    ENABLE = CheckboxField(label="ENABLE")  # 表示しないので翻訳しない

    def __init__(self, *args, **kwargs):
        prefix = os.path.basename(os.path.dirname(
                sys.modules[self.__module__].__file__))
        super(Form, self).__init__(prefix=prefix, *args, **kwargs)

    def clean(self):
        if not self.cleaned_data.get('ENABLE', None):
            self._errors.clear()
        return self.cleaned_data
