# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf.urls import patterns, include, url
from root.modules.utils import pwd, to_importable_path as to_ipath, is_django_app
import os
import re
#from views import StatusView, MelodyStartView, MelodyStopView
import views


def add(urlpatterns, pdir):
    def __get_child_urls(parent_dir):
        def __get_urls(app_dir):
            app_name = re.split('/', re.sub('/$', '', app_dir))[-1]
            app_urls_ipath = to_ipath('/'.join([app_dir, 'urls.py']))
            return url(r'^' + app_name + '/', include(app_urls_ipath))
        lst = []
        for name in os.listdir(parent_dir):
            child_dir = '/'.join([parent_dir, name])
            if is_django_app(child_dir):
                try:
                    lst.append(__get_urls(child_dir))
                except:
                    pass
        return lst

    try:
        entrys = __get_child_urls(pdir)
        for entry in entrys:
            urlpatterns += patterns('', entry)
    except:
        import traceback
        open("/tmp/ms", "w").write(traceback.format_exc())

urlpatterns = patterns('',
    url(r'^$', 'root.admin.views.root'),
    url(r'^main$', 'root.admin.views.main'),
    url(r'^status$', views.StatusView.as_view()),
    url(r'^mstart$', views.MelodyStartView.as_view()),
    url(r'^mstop$', views.MelodyStopView.as_view()),
    url(r'^helpon$', views.HelpOnView.as_view()),
    url(r'^helpoff$', views.HelpOffView.as_view()),
    #url(r'^wait_timeout$', 'root.admin.views.wait_timeout'),
    url(r'^menu$', 'root.admin.views.menu'),
)
add(urlpatterns, pwd())
