# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
#from root.modules.view import FuncView
from project.view import FuncView
import settings
from .. import settings as ps
from project.fal.group import Group
from project.fal.quota import Quota


def root(request):
    return HttpResponseRedirect('./add')


class AddView(FuncView):
    from ..modules.form import Form
#    from ..modules.group import Group
    views = ['add', 'list']

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': self.Form(initial={}),
                'quota_enable': Quota().is_enabled()}}

    def view_add(self, request):
        with self.processing(constname='ERR_GROUP_STATE_CHANGE') as p:
            form = self.Form(data=request.POST)
            p.break_if_state_change()

            if form.is_valid():
                name = form.cleaned_data['name']
                quota = form.cleaned_data['quota']
                members = form.cleaned_data['groupusers']

                obj = Group()
                obj.add(name, quota=quota, members=members)
                self.set_message(obj.get_message())
                p.result(obj.get_result(boolean=True))
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': form,
                'quota_enable': Quota().is_enabled()}}

    def view_list(self, request):
        return {self.KEY_REDIRECT: '../../list'}

add = AddView.as_view()
