# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from root.modules.form import BaseForm
from project.view import FuncView
import settings
from .. import settings as ps
from project.fal.group import Group
from project.forms.fields.extras.group import MultiSelectGroupField


def root(request):
    return HttpResponseRedirect('./delete')

class DeleteForm(BaseForm):
    def __init__(self, *args, **kwargs):
        super(DeleteForm, self).__init__(*args, **kwargs)
        self.fields['groups_'] = MultiSelectGroupField(
                required=False)
        self.fields['groups'] = MultiSelectGroupField(
                label=_(u'Deletion Group'),
                required=True)

class DeleteView(FuncView):
#    from ..modules.group import Group
    views = ['delete', 'list']

    def view(self, request, name):
        form = DeleteForm(initial={'groups': [name]})
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {"form": form}}
#            self.KEY_TEMPLATE_DIC: {"name": name}}

    def view_delete(self, request, name):
        with self.processing(constname='ERR_GROUP_STATE_CHANGE') as p:
            form = DeleteForm(data=request.POST)
            p.break_if_state_change()

            result = True
            if form.is_valid():
                group = Group()
                for name in form.cleaned_data['groups']:
                    group.delete(name)
                    self.set_message(group.get_message())
                    if not group.get_result(boolean=True):
                        result = False
            p.result(result)
            form = DeleteForm()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}

    def view_list(self, request, name):
        return {
            self.KEY_REDIRECT: 
                "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}

delete = DeleteView.as_view()
