# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
#from root.modules.view import FuncView
from project.view import FuncView
import settings
from .. import settings as ps
from project.fal.group import Group
from project.fal.quota import Quota


def root(request):
    return HttpResponseRedirect('./modify')
    
class ModifyView(FuncView):
    from ..modules.form import Form

    views = ['modify', 'list']
    URL = '/'.join([settings.MENU_URL, 'modify'])

    def view(self, request, name):
        group = Group()
        config = group.load().get(name, {})
        if config is {}:
            name = ''
        initial = {
            'name': name,
            'quota': config.get('quota', ''),
            'groupusers': config.get('members', [])}
        form = self.Form(modify=True, initial=initial)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': form,
                'url': self.URL,
                'quota_enable': Quota().is_enabled()}}

    def view_modify(self, request, name):
        form = self.Form(modify=True, data=request.POST)
        result = False
        if self.action.start(constname="ERR_GROUP_STATE_CHANGE"):
            if form.is_valid():
                name = form.cleaned_data['name']
                quota = form.cleaned_data['quota']
                members = form.cleaned_data['groupusers']

                group = Group()
                group.modify(name, quota=quota, members=members)
                self.set_message(group.get_message())
                result = group.get_result(boolean=True)
        self.action.end(result=result)
        return {
             self.KEY_TEMPLATE: self.TEMPLATE,
             self.KEY_TEMPLATE_DIC: {
                 'form': form,
                 'url': self.URL,
                 'quota_enable': Quota().is_enabled()}}

    def view_list(self, request, name):
        return {
               self.KEY_REDIRECT:
                   "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}

modify = ModifyView.as_view()
