# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from root.modules.form import BaseForm
from project.fal.quota import Quota as FQuota

from project.forms.fields.extras.group import GroupNameField, SelectGroupField
from project.forms.fields.extras.user import MultiSelectUserField
from project.forms.fields.extras.quota import QuotaLimitField


class Form(BaseForm):
    from root.modules.form.fields.text import TextField

    def __init__(self, modify=False, *args, **kwargs):
        super(Form, self).__init__(*args, **kwargs)
        if modify:
            self.fields['name'] = SelectGroupField(label=_(u'name'))
        else:
            self.fields['name'] = GroupNameField(label=_(u'name'))
        self.fields['quota'] = QuotaLimitField(
                attrs=None if FQuota().is_enabled() else {'readonly': 'readonly'},
                label=_(u'quota'),
                required=False)
        self.fields['ungroupusers'] = MultiSelectUserField(
                label=_('ungroupusers'),
                required=False)
        self.fields['groupusers'] = MultiSelectUserField(
                label=_('groupusers'),
                required=False)
