# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
#from django.core import validators
#from django.core.exceptions import ValidationError
from project.view import FuncView
from root.modules.form import BaseForm
import settings
from .. import settings as ps

from project.fal.user import User
from project.fal.quota import Quota
from ..modules.form import Form as UserSettingForm


def root(request):
    return HttpResponseRedirect('./add')


class AddView(FuncView):
    views = ['add', 'list']

    def view(self, request):
        form = UserSettingForm()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': form,
                'quota_enable': Quota().is_enabled()}}


    def view_add(self, request):
        with self.processing(constname="ERR_USER_STATE_CHANGE") as p:
            form = UserSettingForm(data=request.POST)
            p.break_if_state_change()

            if form.is_valid():
                name = form.cleaned_data['name']
                fullname = form.cleaned_data['fullname']
                desc = form.cleaned_data['desc']
                passwd = form.cleaned_data['passwd1']
                quota = form.cleaned_data['quota']
                gid = form.cleaned_data['primary_group']

                user = User()
                user.add(name,
                        fullname=fullname,
                        desc=desc,
                        passwd=passwd,
                        gid=int(gid) if gid else None,
                        quota=quota)
                self.set_message(user.get_message())
                p.result(user.get_result(boolean=True))
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': form,
                'quota_enable': Quota().is_enabled()}}
#
#    def view_list(self, request):
#        return {self.KEY_REDIRECT:
#                "/".join([ps.MENU_URL, ps.LIST_APPLI, ps.LIST_VIEW])}

add = AddView.as_view()
