# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from root.modules.form import BaseForm

from project.fal.user import User
from project.forms.fields.extras.user import MultiSelectUserField


def root(request):
    return HttpResponseRedirect('./delete')


class DeleteForm(BaseForm):
    def __init__(self, *args, **kwargs):
        super(DeleteForm, self).__init__(*args, **kwargs)
        self.fields['users_'] = MultiSelectUserField(required=False)
        self.fields['users'] = MultiSelectUserField(
                label=_(u'Deletion User'),
                required=True)


class DeleteView(FuncView):

    views = ['delete', 'list']

    def view(self, request, name):
        form = DeleteForm(initial={'users': [name]})
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}

    def view_delete(self, request, name):
        with self.processing(constname='ERR_USER_STATE_CHANGE') as p:
            form = DeleteForm(data=request.POST)
            p.break_if_state_change()

            result = True
            if form.is_valid():
                uobj = User()
                for name in form.cleaned_data['users']:
                    uobj.delete(name)
                    self.set_message(uobj.get_message())
                    if not uobj.get_result(boolean=True):
                        result = False
            p.result(result)
            form = DeleteForm()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}


delete = DeleteView.as_view()
