# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from root.modules.form import BaseForm
from project.fal.quota import Quota as FQuota

from project.forms.fields.extras.username import UserNameField
from project.forms.fields.extras.user import SelectUserField
from project.forms.fields.extras.username import UserFullNameField
from project.forms.fields.extras.comment import CommentField
from project.forms.fields.extras.quota import QuotaLimitField
from project.forms.fields.extras.landiskpass import LanDiskPassField
from project.forms.fields.extras.group import SelectGroupField


class Form(BaseForm):
    name = UserNameField(label=_(u'User Name'))
    passwd1 = LanDiskPassField(label=_(u'password'), required=False)
    passwd2 = LanDiskPassField(label=_(u'password confirm'), required=False)
    fullname = UserFullNameField(label=_(u'fullname'), required=False)
    desc = CommentField(label=_(u'comment'), required=False)
    primary_group = SelectGroupField(
            label=_(u'primary group'),
            key="gid",
            required=False)

    def __init__(self, modify=False, *args, **kwargs):
        super(Form, self).__init__(*args, **kwargs)
        if modify:
            self.fields['name'] = SelectUserField(label=_(u'User Name'))
        self.fields['primary_group'] = SelectGroupField(
                label=_(u'primary group'),
                key="gid",
                required=False)
        self.fields['quota'] = QuotaLimitField(
                attrs=None if FQuota().is_enabled() else {'readonly': 'readonly'},
                label=_(u'quota limit'),
                required=False)

    def clean(self):
        from django import forms
        passwd1 = self.cleaned_data.get('passwd1', None)
        passwd2 = self.cleaned_data.get('passwd2', None)
        if passwd1 != passwd2:
            raise forms.ValidationError(_('Password unmatch'))  # FIXME msg
        return self.cleaned_data
