# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import os

from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.view import StatusView
from root.modules.form import BaseForm
import settings

from project.fal.volctrl import Volctrl


def root(request):
    return HttpResponseRedirect('./checkdisk')


class View(FuncView):
    class Form(BaseForm):
        pass

    views = ['execute']

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {}}

    def view_execute(self, request):
        with self.processing(constname='ERR_VOLUME_STATE_CHANGE') as p:
            p.break_if_state_change()

            vobj = Volctrl()
            vobj.fsck(volume=vobj.VOLUME['internal'][1], fs='xfs')
            self.set_message(vobj.get_message())
            p.result(vobj.get_result(boolean=True))
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {}}


class CheckdiskStatusView(StatusView):
    STATUS_FILE_PATH = "/mnt/data/conf/volume/status/sataraid1/fsck"


checkdisk = View.as_view()
status = CheckdiskStatusView.as_view()
