# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import os

from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.view import StatusView
from root.modules.form import BaseForm
import settings

from project.fal.raidctrl import Raidctrl
from project.fal.volctrl import Volctrl
from project.forms.fields.extras.agree import AgreeField


def root(request):
    return HttpResponseRedirect('/'.join([settings.MENU_URL, 'forcerestore']))


class View(FuncView):
    class Form(BaseForm):
        agree = AgreeField(label=_(u'agree'))

    views = ['execute']

    def view(self, request):
        form = self.Form()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'forcerestore_status': ForcerestoreStatusView()._status(),
                'form': form}}

    def view_execute(self, request):
        with self.processing(constname='ERR_VOLUME_STATE_CHANGE') as p:
            form = self.Form(data=request.POST)
            p.break_if_state_change()
            if form.is_valid():
                robj = Raidctrl()
                vobj = Volctrl()

                robj.forcestart()
                vobj.mount(volume=vobj.VOLUME['internal'][1], log=False)

                self.set_message(robj.get_message())
                p.result(robj.get_result(boolean=True))
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'forcerestore_status': ForcerestoreStatusView()._status(),
                'form': form}}


class ForcerestoreStatusView(StatusView):
    def _status(self):
        from project.fal.volinfo import Volinfo
        return Volinfo().status(volume="sataraid1", humanize=True)


forcerestore = View.as_view()
status = ForcerestoreStatusView.as_view()
