# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from .. import settings as ps


def is_menu_item():
    try:
        from product_conf import STOR_IF_TO_VOL
        from project.fal.raidctrl import Raidctrl
        from project.fal.volctrl import Volctrl
        from project.utils import get_mirroring_device
        if Raidctrl().query(depth=1)['status'] == 'fail':
            return True
        typ, i = get_mirroring_device()
        status = Volctrl().status(volume=STOR_IF_TO_VOL[typ][i])
        if status == u"recoverablemirror":
            return True
        return False
    except:
        return True

# unique

# common
NAME = 'mirror'
ID = ps.ID + NAME
IS_ENABLE = True
NAME_FORDISPLAY = _(u'Restore from Mirror disk')
IS_MENU_ITEM = IS_ENABLE and is_menu_item()
IS_MENU_TAIL = True
MENU_ORDER = 500
MENU_URL = '/'.join([ps.MENU_URL, NAME])
MENU_ICON = 'RaidReturn.png'

def crash_safe():
    return True

MENU_HELP_TEXT = u"" if _(u"MENU_HELP_TEXT: volume internal mirror") == u"MENU_HELP_TEXT: volume internal mirror" else _(u"MENU_HELP_TEXT: volume internal mirror")
