# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import os

from django.utils.translation import ugettext as _
from django.http import HttpResponseRedirect
from django.core import validators
from django.core.exceptions import ValidationError
from project.view import FuncView
from project.view import StatusView
from root.modules.form import BaseForm
import settings

from project.fal.raidctrl import Raidctrl


def root(request):
    return HttpResponseRedirect('./mirror')


class View(FuncView):
    class Form(BaseForm):
        pass

    views = ['execute']

    def view(self, request):
        form = self.Form()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'status': MirrorStatusView()._status(),
                'form': form}}

    def view_execute(self, request):
        with self.processing(constname='ERR_VOLUME_STATE_CHANGE') as p:
            form = self.Form(data=request.POST)
            p.break_if_state_change()
            if form.is_valid():
                robj = Raidctrl()
                p.result(robj.mirrorrestore())
                self.set_message(robj.get_message())
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'status': MirrorStatusView()._status(),
                'form': form}}


class MirrorStatusView(StatusView):
    def _status(self):
        from project.fal.volinfo import Volinfo
        return Volinfo().status(volume="sataraid1", humanize=True)


mirror = View.as_view()
status = MirrorStatusView.as_view()
