# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import os
from django.utils.translation import ugettext as _
from project.view import FuncView
from root.modules.form import BaseForm
import settings

from project.forms.fields.extras.disk import SelectRaidDiskField
from project.fal.command import get_message as fgettext
from root.admin.volume.modules.utils import remove


class View(FuncView):
    class Form(BaseForm):
        def __init__(self, *args, **kwargs):
            super(View.Form, self).__init__(*args, **kwargs)
            self.fields['disk'] = SelectRaidDiskField(label=_(u'Remove Disk'), required=True)

    views = ['execute']

    def view(self, req):
        form = self.Form()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}

    def view_execute(self, req):
        with self.processing(constname="ERR_VOLUME_STATE_CHANGE") as p:
            form = self.Form(data=req.POST)
            p.break_if_state_change()

            if form.is_valid():
                disk = form.cleaned_data['disk']
                result, msgcode = remove(disk)
                if p.result(result):
                    form = self.Form()
                self.set_message(fgettext(msgcode, is_log=True))
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {'form': form}}
