# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.forms.formsets import formset_factory
from project.view import FuncView
import os
from project.forms.fields.checkbox import CheckboxField
from project.forms.fields.extras.fqdn import FQDNField
from project.forms.fields.extras.portnum import RemotePortNumberField
from project.fal.lockkey import Lockkey


KEYSERVER_NUM = 3
DEFAULT_PORT = 51056


class ConvertForm(forms.Form):

    pass


class ConvertView(FuncView):

    views = ['apply', 'convert']

    def view(self, request):
        form = ConvertForm()

        template = os.path.join(self.TEMPLATES, 'template.html')
        dictionary = {
            'form': form,
        }
        return {
            self.KEY_TEMPLATE: template,
            self.KEY_TEMPLATE_DIC: dictionary,
        }

    def view_convert(self, request):
        form = ConvertForm(data=request.POST)

        with self.processing(constname="ERR_LOCKKEY_STATE_CHANGE") as p:
            if form.is_valid():
                lockkey = Lockkey()
                p.result(lockkey.set_lockkey("transform"))
                self.set_message(lockkey.get_message())

        template = os.path.join(self.TEMPLATES, 'template.html')
        dictionary = {
            'form': form,
        }
        return {
            self.KEY_TEMPLATE: template,
            self.KEY_TEMPLATE_DIC: dictionary,
        }
