# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.http import HttpResponseRedirect
from project.view import FuncView
from project.fal.command import get_message
from fal_info import Results
from ..modules.lockkey import LockKey


def root(request):
    return HttpResponseRedirect('./deletekey')


class View(FuncView):
    views = ['delete']

    def __delete_key(self):
        result = LockKey().delete_key()
        if result == Results.OK:
            self.set_message(get_message('MSG_LOCKKEY_DELETE', is_log=True))
            return True
        else:
            if result == Results.FILE_NOT_FOUND:
                self.set_message(get_message('ERR_LOCKKEY_NO_KEY_FILE'))
            elif result == Results.DEVICE_NOT_FOUND:
                self.set_message(get_message('ERR_LOCKKEY_DISK_NOT_FOUND'))
            else:
                self.set_message(
                        get_message('ERR_LOCKKEY_DELETE', is_log=True))
            return False

    def view(self, request):
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {}}

    def view_delete(self, request):
        with self.processing(constname="ERR_LOCKKEY_STATE_CHANGE") as p:
            rst = False
            p.break_if_state_change()
            rst = self.__delete_key()
            p.result(rst)
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {}}

deletekey = View.as_view()
