# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf import settings
from django.utils.translation import ugettext as _
from .. import settings as ps


# unique
PORT = ps.PORT
USB = ps.USB
ENABLED_TABLE = dict([(str(usb["port"]), len(usb.get("modelist")) > 1)
                      for usb in settings.FEATURES(["deviceinfo", "usblist"], default=[]) if usb.get("port")])

# common
NAME = 'mode'
ID = ps.ID + NAME
IS_ENABLE = ENABLED_TABLE.get(str(PORT), True)
NAME_FORDISPLAY = _(u'mode setting')
IS_MENU_ITEM = IS_ENABLE
IS_MENU_TAIL = True
MENU_ORDER = 300
MENU_URL = '/'.join([ps.MENU_URL, NAME])
MENU_ICON = 'Mode.png'

help_table = {
    'usb1': u"" if _(u"MENU_HELP_TEXT: volume usb1 mode") == u"MENU_HELP_TEXT: volume usb1 mode" else _(u"MENU_HELP_TEXT: volume usb1 mode"),
    'usb2': u"" if _(u"MENU_HELP_TEXT: volume usb2 mode") == u"MENU_HELP_TEXT: volume usb2 mode" else _(u"MENU_HELP_TEXT: volume usb2 mode"),
    'usb3': u"" if _(u"MENU_HELP_TEXT: volume usb3 mode") == u"MENU_HELP_TEXT: volume usb3 mode" else _(u"MENU_HELP_TEXT: volume usb3 mode"),
    'usb4': u"" if _(u"MENU_HELP_TEXT: volume usb4 mode") == u"MENU_HELP_TEXT: volume usb4 mode" else _(u"MENU_HELP_TEXT: volume usb4 mode"),
}
MENU_HELP_TEXT = help_table.get(USB, NAME_FORDISPLAY)
