# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from .. import settings as ps
import os
from django.conf import settings


def __is_enabled(port):
    portlist = [str(usb["port"]) for usb in settings.FEATURES(["deviceinfo", "usblist"])]
    port = str(port)
    return bool(len([p for p in portlist if p == port]))

def __port_to_protocol(port):
    for usb in settings.FEATURES(["deviceinfo", "usblist"]):
        if int(usb.get("port")) == port:
            return usb.get("protocol", None)
    return None

# unique
name_table = {
    'usb1': _(u'USB1'),
    'usb2': _(u'USB2'),
    'usb3': _(u'USB3'),
    'usb4': _(u'USB4'),
}
order_table = {
    'usb1': 200,
    'usb2': 300,
    'usb3': 400,
    'usb4': 500,
}
USB = __file__.split(os.sep)[-2]
PORT = {
    "usb1": 1,
    "usb2": 2,
    "usb3": 3,
    "usb4": 4,
}[__file__.split(os.sep)[-2]]
PROTOCOL = __port_to_protocol(PORT)


# common
NAME = USB
ID = ps.ID + NAME
IS_ENABLE = __is_enabled(PORT)
NAME_FORDISPLAY = name_table[USB]
IS_MENU_ITEM = IS_ENABLE
IS_MENU_TAIL = False
MENU_ORDER = order_table[USB]
MENU_URL = '/'.join([ps.MENU_URL, NAME])
MENU_ICON = u"USB%s%s.png" % (PORT, (u"_%s" % PROTOCOL) if PROTOCOL else u"")

help_table = {
    'usb1': u"" if _(u"MENU_HELP_TEXT: volume usb1") == u"MENU_HELP_TEXT: volume usb1" else _(u"MENU_HELP_TEXT: volume usb1"),
    'usb2': u"" if _(u"MENU_HELP_TEXT: volume usb2") == u"MENU_HELP_TEXT: volume usb2" else _(u"MENU_HELP_TEXT: volume usb2"),
    'usb3': u"" if _(u"MENU_HELP_TEXT: volume usb3") == u"MENU_HELP_TEXT: volume usb3" else _(u"MENU_HELP_TEXT: volume usb3"),
    'usb4': u"" if _(u"MENU_HELP_TEXT: volume usb4") == u"MENU_HELP_TEXT: volume usb4" else _(u"MENU_HELP_TEXT: volume usb4"),
}
MENU_HELP_TEXT = help_table.get(USB, NAME_FORDISPLAY)
