# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core.exceptions import ValidationError
from project.view import RootView
from project.fal.sysinfo import SysInfo
import os
from django.conf import settings


NarSuS = "narsus" in settings.FEATURES(["functionlist"])


class ChangeListView(RootView):
    views = []
    REQUIRED_LOGIN = True
    NOT_LOGINED_URL = '/login'

    def view(self, request):
        condition = "normal"
        infos = {}
        try:
            sysinfo = SysInfo()
            infos = sysinfo.query()
            condition = infos.get('condition')
            if condition != 'updated':
                return {
                    self.KEY_REDIRECT: '/admin/narsus/guide' if NarSuS else '/admin/main',
                }
            sysinfo.clear()
        except:
            return {
                self.KEY_REDIRECT: '/admin/narsus/guide' if NarSuS else '/admin/main',
            }

        return {
            self.KEY_TEMPLATE: os.path.join(self.TEMPLATES, 'template.html'),
            self.KEY_TEMPLATE_DIC: {
                "URL": "/admin/narsus/guide" if NarSuS else "/admin/main",
                "infos": infos,
                'IS_LOGINED': True,
            },
        }
