# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from project.view import RootView
from datetime import datetime
from subprocess import call, Popen, PIPE
import os


class DatetimeForm(forms.Form):

    datetime = forms.DateTimeField(label=_(u"DateTime"),
                                   # widget=forms.DateTimeInput())
                                   widget=forms.DateTimeInput(attrs={"readonly": "readonly"}))


class DatetimeView(RootView):
    REQUIRED_LOGIN = False

    views = ["apply"]

    def view(self, request):
        form = DatetimeForm(initial={"datetime": datetime.now()})
        messages = []

        messages.append("日時を設定してください。")

        template = os.path.join(self.TEMPLATES, "datetime.html")
        dictionary = {
            "form": form,
            "messages": messages,
        }
        return {
            self.KEY_TEMPLATE: template,
            self.KEY_TEMPLATE_DIC: dictionary,
        }

    def view_apply(self, request):
        form = DatetimeForm(data=request.POST)
        messages = []

        if form.is_valid():
            self.save(form.cleaned_data["datetime"])
            form = DatetimeForm(initial={"datetime": datetime.now()})
            messages.append("日時を設定しました。")
            messages.append("表示されている日時が正しいことを確認してください。")
        else:
            messages.append("日時を設定できませんでした。")

        template = os.path.join(self.TEMPLATES, "datetime.html")
        dictionary = {
            "form": form,
            "messages": messages,
        }
        return {
            self.KEY_TEMPLATE: template,
            self.KEY_TEMPLATE_DIC: dictionary,
        }

    def save(self, dt):
        result = False
        try:
            with open(os.devnull, "wb") as DEVNULL:
                proc = Popen(["sudo", "date", "--set", dt.strftime("%Y-%m-%d %H:%M:%S")],
                             stdout=DEVNULL,
                             stderr=DEVNULL)
                proc.communicate()
                result = proc.returncode == 0
        except:
            result = False
        finally:
            return result
