# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf import settings
from project.view import RootView
from django.http import HttpResponse
from datetime import datetime
import os
import tarfile


class View(RootView):
    REQUIRED_LOGIN = True
    NOT_LOGINED_URL = '/login/gate/_log/_log.cgi'

    def _comp(self, paths=[], tgzfile='_log.tgz'):
        from subprocess import call
#        tmpdir = os.path.join(settings.TMP, 'log')
        tmpdir = '/tmp/log'
        call(['sudo', 'rm', '-r', tmpdir])
        for path in paths:
#            todir = os.path.join(tmpdir, os.path.dirname(path))
            todir = tmpdir + os.path.dirname(path)
            try:
                os.makedirs(todir)
            except OSError:
                pass
            call(['sudo', 'cp', '-rpL', path, todir])
        result = call(['sudo', 'tar', 'czvfh', tgzfile, '-C', tmpdir, '.'])
        call(['sudo', 'chmod', '777', tgzfile])
        return result

#        from subprocess import call
#        cmd = ['sudo', 'tar', 'czvf', tgzfile] + paths
#        rtn = call(cmd)
#        call(['sudo', 'chmod', '777', tgzfile])
#        return rtn

#        tgz = tarfile.open(tgzfile, 'w:gz')
#        for dir_ in dirs:
#            for root, ___, files in os.walk(dir_):
#                for file_ in files:
#                    try:
#                        tgz.add(os.path.join(root, file_))
#                    except:
#                        try:
#                            msg = ' CompErr: (%s)' % os.path.join(root, file_)
#                            self.logger.debug(msg)
#                        except:
#                            pass
#        tgz.close()

#        def __tgzadd(tgz, path):
#            if os.path.isdir(path):
#                for root, ___, files in os.walk(path):
#                    for file_ in files:
#                        try:
#                            __tgzadd(tgz, os.path.join(root, file_))
#                        except:
#                            pass
#            else:
#                try:
#                    tgz.add(path)
#                except:
#                    pass
#        tgz = tarfile.open(tgzfile, 'w:gz')
#        for d in dirs:
#            __tgzadd(tgz, d)
#        tgz.close()

    def _mksmartdata(self):
        try:
            from product_conf import DEV_DIR
            from product_conf.devinfo import SATA_HDD_DEV_LIST
            from subprocess import Popen, PIPE, call
            TEMP_DIR = getattr(settings, 'TMP', '/var/tmp/www')
            SMARTCTL_DIR = os.path.join(TEMP_DIR, 'smartctl')
            if not os.path.exists(SMARTCTL_DIR):
                os.makedirs(SMARTCTL_DIR)
            for satadX in SATA_HDD_DEV_LIST:
                devsatadX = os.path.join(DEV_DIR, satadX)
                if not os.path.exists(devsatadX):
                    continue
                proc = Popen(
                        ['sudo', '/usr/local/bin/smartctl', '-a', devsatadX],
                        stdout=PIPE,
                        stderr=PIPE)
                (stdout, stderr) = proc.communicate()
                with open(os.path.join(SMARTCTL_DIR, satadX), 'w') as f:
                    f.write(stdout)
        except:
            pass

    def _mkdata(self):
        self._mksmartdata()

    def rm(self, path):
        from subprocess import call
        return call(['sudo', 'rm', path])

    def view(self, request):
        fname = datetime.now().strftime("%Y%m%d%H%M%S.tgz")
        fpath = "/tmp/%s" % fname
        paths = [
                '/var',
                '/mnt/data/log',
                '/mnt/data/xmlconf',
                '/mnt/data/etc',
                '/mnt/data/conf',
                '/proc/bus/usb/devices',
                '/proc/cmdline',
                '/proc/cpuinfo',
                '/proc/diskstats',
                '/proc/interrupts',
                '/proc/iomem',
                '/proc/ioports',
                '/proc/loadavg',
                '/proc/meminfo',
                '/proc/mdstat',
                '/proc/mounts',
                '/proc/partitions',
                '/proc/scsi/scsi',
                '/proc/stat',
                '/proc/swaps',
                '/proc/timer_list',
                '/proc/uptime',
                '/proc/vmstat',
                '/proc/zoneinfo',
                '/proc/version',
        ]
        self._mkdata()
        self._comp(paths=paths, tgzfile=fpath)
        #self._rmdata()  # 不要?
        response = HttpResponse(
                open(fpath, "r").read(),
                mimetype="application/x-gzip")
        response['Content-Disposition'] = 'attachment; filename=%s' % fname
        self.rm(fpath)
        return {self.KEY_RESPONSE: response}
