# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from subprocess import call, Popen, PIPE
import re
import os
import sys
import glob
import time


def snmpget(oid):
    proc = Popen(
            ['snmpget', '-v', '2c', '-Oqv', '-c', 'public', 'localhost', oid],
            stdout=PIPE,
            stderr=PIPE)
    (stdout, stderr) = proc.communicate()
    return stdout

def meminfo():
    data = {
        'Mem': None,
        'Swap': None,
        'Total': None,
    }
    proc = Popen(['free', '-t'], stdout=PIPE, stderr=PIPE)
    (stdout, stderr) = proc.communicate()
    for tgt in data.keys():
        m = re.search("%s:\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)" % tgt, stdout)
        if m:
            data[tgt] = int(100 * float(m.group(2)) / float(m.group(1)))
        else:
            data[tgt] = 0  # FIXME

    m = re.search("Mem:\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)\s+([0-9]+)", stdout)
    data['Cache'] = int(100 * float(m.group(6)) / float(m.group(1))) if m else 0

    return data
