# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from project.view import RootView
from django.http import HttpResponse
from subprocess import Popen, PIPE
import os


class View(RootView):
    REQUIRED_LOGIN = False

    def _smartctl(self, sata):
        try:
            sata = {
                1: '/dev/satad1',
                2: '/dev/satad2',
                3: '/dev/satad3',
                4: '/dev/satad4',
                5: '/dev/satad5',
                6: '/dev/satad6',
            }[sata]
            sd = os.path.join(os.path.dirname(sata), os.readlink(sata))
            cmd = ['sudo', 'smartctl', '-a', sd]
            proc = Popen(cmd, stdout=PIPE)
            proc.wait()
            return proc.stdout.read()
        except:
            return ''

    def view(self, request):
        sataportnums = range(1, 7)
        try:
            from product_conf.devinfo import SATA_PORT_NO_LIST
            sataportnums = [int(no) for no in SATA_PORT_NO_LIST]
        except:
            pass

        response = HttpResponse(
"""model is HDL-H

%(sata)s""" % {'sata': '\n'.join([
"""=== sata%s ===
%s""" % (n, self._smartctl(n)) for n in sataportnums]),
            },
            mimetype="text/plain")
        return {self.KEY_RESPONSE: response}
