# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
try:
    from root.settings import LOGIN_TIMEOUT
except:
    LOGIN_TIMEOUT = 600

from utils import touch
import os
import time


class Auth(object):
    def __init__(self):
        self.LOGINFILE_PREFIX = "/tmp/login."
        self.LOGINKEY = "user"
        self.LOGIN_TIMEOUT = LOGIN_TIMEOUT

    def login(self, session=None, user="admin", password=""):
        try:
            if not session:
                return False
#            if self.is_logined_session(session):
#                return False  # already login
#            if self.is_logined_user(user=user):
#                return False  # already login
            if not True:  # FIXME if [user]'s password is [password].
                return False  # password error
            touch(self.LOGINFILE_PREFIX + user)
            session[self.LOGINKEY] = user
            session.set_expiry(self.LOGIN_TIMEOUT)
            return True
        except:
            self.logout(session=session)
            return False

    def logout(self, session=None):
        try:
            if not session:
                return False

            # そもそもログイン状態でない (恐らくsessionがタイムアウトした)
            if self.LOGINKEY not in session:
                return True

            login_file_path = self.LOGINFILE_PREFIX + session[self.LOGINKEY]
            if os.path.exists(login_file_path):
                try:
                    os.remove(login_file_path)
                except:
                    return False
            else:
                pass  # ログインファイルがない -> 既にログアウトしている
            #session.clear()
            del session[self.LOGINKEY]
            return True
        except:
            return False

    def is_logined_session(self, session):
        try:
            user = session[self.LOGINKEY]
            session.modified = True  # ログイン時間延長
            touch(self.LOGINFILE_PREFIX + user)  # ログイン時間延長
            return True
        except:
            return False

    def is_logined_user(self, user="admin"):
        try:
            loginfile = self.LOGINFILE_PREFIX + user
            if os.path.exists(loginfile):
                ftime = os.path.getmtime(loginfile)
                now = time.time()
                if int(ftime) + int(self.LOGIN_TIMEOUT) - int(now) > 0:
                    return True
                return False
            return False
        except:
            return False
