# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from field import Field


class CheckboxField(forms.BooleanField, Field):

    def __init__(self,
            validators=[],
            widget=None,  # 無視
            label=None,
            initial=False,
            required=True,
            help_text=None):
        #widget = forms.widgets.CheckboxInput
        forms.BooleanField.__init__(self,
                widget=widget,
                initial=initial,
                required=False,
                help_text=help_text,
                label=label)

        validators = [] + list(validators)
        Field.init(self, validators=validators, required=required)

    def clean(self, value):
        return Field.clean(self, value)
