# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from validators.required import RequiredValidator


class Field(forms.Field):
    # FIXME
    #error_messages = {
    #    'invalid': _('invalid')}
    #
    #validators = []

    def __init__(self,
            validators=[],
            widget=forms.widgets.TextInput,
            label=None,
            initial=None,
            required=True,
            help_text=None,
            *args, **kwargs):
        forms.Field.__init__(self,
                widget=widget,
                label=label,
                required=required,
                initial=initial,
                *args, **kwargs)

        validators = [] + list(validators)
        self.init(validators=validators, required=required)

    def init(self, validators=[], required=True):
        self.validators = []
        if required:
            self.validators.append(RequiredValidator())
        self.validators = self.validators + list(validators)

    def to_python(self, value):
        return value

    def clean(self, value):
        cleaned_value = self.to_python(value)

        errors = []
        for v in self.validators:
            try:
                v(cleaned_value)
            except forms.ValidationError, e:
                # FIXME
                #if hasattr(e, 'code') and e.code in self.error_messages:
                #    message = self.error_messages[e.code]
                #    if e.params:
                #        message = message % e.params
                #    errors.append(message)
                #else:
                #    errors.extend(e.messages)
                errors.extend(e.messages)
        if errors:
            raise forms.ValidationError(errors)

        return cleaned_value
