# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from field import Field


class HiddenField(forms.CharField, Field):

    def __init__(self,
            validators=[],
            widget=None,
            label=None,
            initial='',
            required=True,
            help_text=None):
        forms.CharField.__init__(self,
                widget=forms.widgets.HiddenInput,
                initial=initial,
                label=label)

        validators = [] + list(validators)
        Field.init(self, validators=validators, required=required)

    def clean(self, value):
        return Field.clean(self, value)
