# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from field import Field
from django import forms
from validators import required


class PasswordField(forms.CharField, Field):
    def __init__(self,
        max_length=None,
        validators=[],
        widget=None,
        label=None,
        initial='',
        help_text=None,
        required=True):
        forms.CharField.__init__(self,
            max_length=max_length,
            widget=forms.widgets.PasswordInput(render_value=True),
            label=label,
            #required=required,,
            #help_text=help_text,
            initial=initial)

        validators = [] + list(validators)
        Field.init(self, validators=validators, required=required)

    def clean(self, value):
        return Field.clean(self, value)
