# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.utils.safestring import mark_safe
from django.utils.encoding import force_unicode
from field import Field
from validators import inchoices


class SelectField(forms.ChoiceField, Field):

    def __init__(self,
            choices=(),  # 選択肢
            validators=[],
            widget=None,
            label=None,
            initial=0,
            required=True,
            help_text=None):
        #widget = forms.widgets.SelectInput()
        #choices = ((1, _(u'enable')), (0, _(u'disable')))
        choices = tuple(choices)
        forms.ChoiceField.__init__(self,
                label=label,
                widget=widget,
                choices=choices,
                initial=initial)

        validators = [
            inchoices.InchoicesValidator(choices=choices)] + list(validators)
        Field.init(self, validators=validators, required=required)

    def clean(self, value):
        return Field.clean(self, value)
