# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from field import Field


class TextField(forms.CharField, Field):

    def __init__(self,
            max_length=None,  # あくまでも入力フィールドのmax
            #min_length=None,
            validators=[],
            widget=None,
            label=None,
            initial='',
            required=True,
            help_text=None):
        forms.CharField.__init__(self,
                max_length=max_length,
                #min_length=min_length,
                widget=widget,  # widget はデフォルトの TextInput で固定
                initial=initial,
                label=label)

        validators = [] + list(validators)
        Field.init(self, validators=validators, required=required)

    def clean(self, value):
        return Field.clean(self, value)
