# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from validator import Validator


class InchoicesValidator(Validator):
    code = 'invalid choice'
    messages = _(u'invalid choice.')
    params = {}

    choices = ()

    def __init__(self, choices=()):
        if isinstance(choices, (list, tuple)):
            self.choices = choices

    def __call__(self, value):
        for k, v in self.choices:
            if str(value) == str(k):
                break
            if value == u'':
                break
        else:
            raise forms.ValidationError(
                self.messages % self.params,
                code=self.code,
                params=self.params)
