# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from validator import Validator


class RequiredValidator(Validator):
    code = 'required'
    messages = _(u'This field is required.')
    params = {}

    EMPTY_VALUES = (None, '', [], (), {})

    def __call__(self, value):
        if value in self.EMPTY_VALUES:
            raise forms.ValidationError(
                    self.messages % self.params,
                    code=self.code,
                    params=self.params)
        else:
            pass
