# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django import forms
import sys
import os
from root.modules.utils import importer as imp, to_importable_path as to_ipath


class BaseForm(forms.Form):
    EXTDIR = None

    def __init__(self, extdir=None, *args, **kwargs):
        super(BaseForm, self).__init__(*args, **kwargs)

        extdir = extdir if extdir else self.EXTDIR
        if extdir:
            self.__add(extdir)

    def __add(self, dname):
        """
        指定されてた名前にディレクトリに存在するファイルを探索し、
        そのファイルに一定の規則で存在するフィールドをこのフォームに追加する
        app/dname/10f.py
                 /20f.py
        fields = {
            'f1': TextField_obj,
            'f2': CheckboxField_obj}
        """
        current = os.path.dirname(sys.modules[self.__module__].__file__)
        dpath = os.path.join(current, dname)
        try:
            for fname in sorted(os.listdir(dpath)):
                fpath = os.path.join(dpath, fname)
                try:
                    m = imp(to_ipath(fpath))
                    reload(m)
                    fields = m.fields
                except:
                    continue
                for name, obj in fields.iteritems():
                    self.fields[name] = obj
        except:
            pass
