# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
import logging

class Common(object):
    log = logging.getLogger("custom")

    def process_request(self, request):
        # FIXME
        #self.log.critical(request.path)
        #self.log.error(request.path)
        #self.log.warning(request.path)
        #self.log.info(request.path)
        #self.log.debug(request.path)

        self.log.debug("")
        self.log.debug("%s: %s" % (request.META['REMOTE_ADDR'], request.path))
        self.log.debug("  session_key: %s" % request.session.session_key)

        return None  # None/HttpResponse

    def process_view(self, request, view_func, view_args, view_kwargs):
        return None  # None/HttpResponse

    def process_response(self, request, response):
        def is_html(string):
            import re
            return re.match('<', string)

        def normalize(html):
            from root.modules.BeautifulSoup import BeautifulSoup as bs
            soup = bs(html)
            return soup.prettify()

        if is_html(response.content):
            response.content = normalize(response.content)
        return response  # HttpResponse

    def process_exception(self, request, exception):
        return None  # None/HttpResponse
