# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from iobase.xmldata import XmlNode
from iobase.exception import NotFoundError
import inspect
import os
import sys
import re



def importer(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod


def to_importable_path(module_fpath):
    for p in sys.path:
        if re.match('^' + p, module_fpath):
            # FIXME
            return re.sub('.py$', '', module_fpath).replace(p + '/', '').replace('/', '.')
    # FIXME
    raise IOError  # not importable


def pwd():
    return os.path.dirname(inspect.currentframe().f_back.f_code.co_filename)


def touch(file):
    open(file, 'w').close()


def is_django_app(dpath):
    if not os.path.isdir(dpath):
        return False
    if os.path.exists(os.path.join(dpath, 'models.py')):
        return True
    if os.path.exists(os.path.join(dpath, 'models.pyc')):
        return True
    return False


def get_inss(dpath, name):
    inss = {}
    try:
        for fname in sorted(os.listdir(dpath)):
            fpath = os.path.join(dpath, fname)
            try:
                inss.update(getattr(importer(to_importable_path(fpath)), name))
            except:
                continue
    except:
        pass
    return inss
