# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.conf.urls import patterns, include, url

FORMAT = '(/[a-zA-Z0-9-_\.]+)*'

urlpatterns = patterns(
    '',
    url(r'^$', 'root.views.root'),
    url(r'^set$', 'root.views.set'),
    url(r'^check$', 'root.views.check'),
    url(r'^setpass(?P<url>%s)$' % FORMAT, 'root.login.views.setpass'),
    url(r'^login(?P<url>%s)$' % FORMAT, 'root.login.views.login'),
    url(r'^logout$', 'root.login.views.logout'),
    url(r'^userpassword(/(?P<username>\w+)){0,1}$',
        'root.userpassword.views.userpassword'),
    url(r'^init/', include('root.init.urls')),
    url(r'^changelist/', include('root.changelist.urls')),
    url(r'^admin/', include('root.admin.urls')),
    url(r'^gate/', include('root.gate.urls')),
)

import os
if os.path.exists(os.path.join(os.path.dirname(os.path.abspath(__file__)), "tool")):
    urlpatterns += patterns('', url(r'^tool/', include('root.tool.urls')))
