# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

from django.http import HttpResponseRedirect
from django.shortcuts import render_to_response
from django.template import RequestContext


def root(request):
    request.session.cleanup()
    request.session.set_test_cookie()
    return HttpResponseRedirect('/set')


def set(request):
    request.session.set_test_cookie()
    return HttpResponseRedirect('/check')


def check(request):
    if request.session.test_cookie_worked():
        request.session.delete_test_cookie()
        return HttpResponseRedirect('/login')
    else:
        return render_to_response(
                'cookie.html',
                {},
                context_instance=RequestContext(request))
