// <div id="slideshow">
//   <div>slide1</div>
//   <div>slide2</div>
//   <div>slide3</div>
// </div>

// var ss = SlideShow('slideshow', {width:100, height:100, interval:3000});
var SlideShow = function(sshow, options) {
	var se = typeof sshow == 'object' ? sshow : document.getElementById(sshow);
	if (! se) { return; }
	this.options = {
		'width': options.width ? options.width + 'px' : '100px',
		'height': options.height ? options.height + 'px' : '100px',
		'interval': options.interval ? options.interval : 3000
	}

	this.zindex = 8;

	// スライド群を束ねる親divを初期化
	se.style.position = 'relative';  // スライドが親div領域から出ないように
	se.style.overflow = 'hidden';  // 同上
	se.style.width = this.options.width;
	se.style.height = this.options.height;

	// スライド群の初期化
	this.slides = Array();
	for (var i=0; i<se.childNodes.length; i++) {
		if (se.childNodes[i].nodeName.toLowerCase() == 'div') {
			se.childNodes[i].style.position = 'absolute';
			se.childNodes[i].style.zIndex = this.zindex;
			se.childNodes[i].style.width = this.options.width;
			se.childNodes[i].style.height = this.options.height;
			//se.childNodes[i].style.backgroundColor = '#ffffff';
			this.slides[this.slides.length] = se.childNodes[i];
		}
	}

	this.count = 0;
	if (this.slides.length > 0) {
		this.slides[this.count].style.zIndex = this.zindex + 2;
		if (this.slides.length > 1) {
			this.slides[this.count + 1].style.zIndex = this.zindex + 1;
		}
	}

	var that = this;
	function _btn(onclick, right_or_left) {
		var btn = document.createElement('div');
		btn.style.width = '20px';
		btn.style.height = that.options.height;
		btn.style.position = 'absolute';
		btn.style.zIndex = that.zindex + 3;
		if (right_or_left == 'right') {
			btn.style.right = 0;
			btn._off = 'url(/static/img/common/Slideshow_02.gif)';
			btn._on = 'url(/static/img/common/_Slideshow_02.gif)';
			btn.style.backgroundImage = btn._off;
			btn.style.backgroundRepeat = 'no-repeat';
			btn.style.backgroundPosition = 'right';
		} else if (right_or_left == 'left') {
			btn.style.left = 0;
			btn._off = 'url(/static/img/common/Slideshow_01.gif)';
			btn._on = 'url(/static/img/common/_Slideshow_01.gif)';
			btn.style.backgroundImage = btn._off;
			btn.style.backgroundRepeat = 'no-repeat';
			btn.style.backgroundPosition = 'left';
		}
		btn.onmouseover = function() {
			this.style.backgroundImage = this._on;
		};
		btn.onmouseout = function() {
			this.style.backgroundImage = this._off;
		};
		btn.onclick = onclick;
		return btn;
	}
	if (this.slides.length > 1) {
		// スライド送りボタン
		se.appendChild(_btn(function(e){ that.next(); }, 'right'));
		// スライド戻しボタン
		se.appendChild(_btn(function(e){ that.prev(); }, 'left'));
	}

	// options.interval [ms] 毎に next
	this._next = function(){ that.next(); };
	this.iNext = setInterval(this._next, this.options.interval);
}

SlideShow.prototype = {
	_prev_or_next: function(counter) {
		clearInterval(this.iNext);
		if (this.slides.length > 1) {
			this.slides[this.count].style.zIndex = this.zindex;
			this.count = counter(this.count, this.slides.length);
			this.slides[this.count].style.zIndex = this.zindex + 2;
			this.slides[counter(this.count, this.slides.length)].style.zindex = this.zindex + 1;
		}
		this.iNext = setInterval(this._next, this.options.interval);
	},
	next: function() {
		this._prev_or_next(function(n, l){ return (n + 1) % l; });
	},
	prev: function() {
		this._prev_or_next(function(n, l){ return (n + l - 1) % l; });
	}
}
