var Status = function(url, id, opts) {

  this.url = url;
  this._elem = $("#" + id);
  if ((! this.url) || ! (this._elem)) {
    var err = new Error();
    err.message = 'argument error!';
    throw err;
  }

  this._opts = opts || {};
  this._opts.interval = this._opts.interval || 3000;
  this._opts.request_args = this._opts.request_args || {};
  this._success = this._opts.success || this._default_success;
  this._error = this._opts.error || this._default_error;
  this._complete = this._opts.complete || this._default_complete;
}

Status.prototype.get = function() {
  var obj = this;
  $.ajax({
    type: "GET",
    url: this.url,
    cache: false,
    data: obj._opts.request_args,
    dataType: "json",
    timeout: 60000,
    success: function(data, dataType) {
      obj._success(data, dataType);
      setTimeout(function() { obj.get(); }, obj._opts.interval);
    },
    error: function(XMLHttpRequest, textStatus, errorThrown) {
      obj._error(XMLHttpRequest, textStatus, errorThrown);
      if (textStatus == 'timeout') setTimeout(function() { obj.get(); }, obj._opts.interval);
    },
    complete: function(XMLHttpRequest, textStatus) {
      obj._complete(XMLHttpRequest, textStatus);
    }
  });
}

Status.prototype._default_success = function(data, dataType) {
  this._elem.text(data.status);
};
Status.prototype._default_error = function(XMLHttpRequest, textStatus, errorThrown) {
};
Status.prototype._default_complete = function(XMLHttpRequest, textStatus) {
};

function nl2br_success(data, dataType) {
  this._elem.html(escapeHTMLByReplace(data.status).replace(/\n/g, "<br/>"));
}
