// 待ち処理用クラス Wait
// 実装として jquery.blockUI.js を用いる
// 待ち開始で画面をブロックし、終了をブロック解除する。

// コンストラクタ
var Wait = function() {
	return this;
}

// 待ち開始メソッド
Wait.prototype.start = function(opt) {
	opt = opt || {};
	opt.timeout = opt.timeout || 500000;

	$.blockUI({
		message: '<p><img src="/media/img/common/waiting.gif" alt="Please wait ..."/></p>',
		css: { zIndex: 10000 },
		overlayCSS: { opacity: 0 }
	});

	this._timer = setTimeout($.unblockUI, opt.timeout); // タイムアウト設定
}

// 待ち終了メソッド
Wait.prototype.stop = function() {
	clearInterval(this._timer); // タイムアウト解除
	$.unblockUI();
}
