# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta

def _import(name):
    mod = __import__(name)
    #mod = __import__(name, {}, {}, [])
    components = name.split('.')
    for c in components[1:]:
        mod = getattr(mod, c)
    return mod

def _to_importable_path(fpath):
    import os, sys, re

    # FIXME
    #cpath = os.path.abspath(os.path.dirname(__file__))
    #sys.path.append(cpath)
    for p in sys.path:
        if re.match('^' + p, fpath):
            return fpath.replace(p + '/', '').replace('.py', '').replace(
                    '/', '.')
    raise # not importable

def get_all_py(dpath):
    import os, re

    files = []

    if not directory:
        dpath = os.path.abspath(os.path.dirname(__file__))

    for dp, dnames, fnames in os.walk(directory):
        for fname in fnames:
            if re.match('.+\.py$', fname):
                fpath = dp + '/' + fname
                files.append(fpath)

    return files

def _get_all_class_and_method(module):
    import inspect

    lst = []
    for obj_name in dir(module):
        print obj_name
        obj = getattr(module, obj_name)
        if callable(obj):
            lst.append(obj)
        if inspect.isclass(obj):
            lst.append(obj)
    return lst

#def has_doctest(module):
#    for obj in _get_all_class_and_method(module):
#        if '>>>' in str(obj.__doc__):
#            return True
#    return False

def get_all_module(dpath):
    modules = []
    for f in get_all_py(dpath):
        try:
            m = _import(_to_importable_path(f))
            modules.append(m)
        except:
            next
    return modules

def run(dpath):
    import doctest

    result = True
    for m in get_all_module(dpath):
        print 'TEST: ' + m.__file__
        r = doctest.testmod(m)
        if r.failed or r.attempted:
            result = False
        print ''
    print 'pass the test?: '
    if result:
        print '    OK'
    else:
        print '    NG'

if __name__ == '__main__':
    import os
    directory = os.path.abspath(os.path.dirname(__file__))
    run(directory)
